////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// iecsupp.cpp                                                                //
// berwacht die Erzeugung von COM-Objekten.                                  //
// (c) 2003 c't/Matthias Withopf                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


#include "iecsupp.h"
#include "config.h"
#define STRICT
#define WIN32_LEAN_AND_MEAN
#pragma warning(disable:4201)
#include <windows.h>
#include <commctrl.h>
#include <commdlg.h>
#include <shlobj.h>
#pragma warning(default:4201)
#include <strsafe.h>
#pragma warning(disable:4995)
#include <shlwapi.h>
#include <winsock2.h>

static char      GlobalLauncherFileName[4 * 1024];
static HINSTANCE GlobalModuleHandle = NULL;
static HANDLE    GlobalBigIcon      = NULL;
static HANDLE    GlobalSmallIcon    = NULL;
static DWORD     GlobalPatchFlags   = pf_Default;
static char      GlobalAppName[4 * 1024];
static char      GlobalConfigKeyName[4 * 1024];
static char      GlobalCfgName[80];
static HMENU     GlobalPopupMenu    = NULL;
static wchar     GlobalWindowsDir[256];
static wchar     GlobalWindowsSxSDir[256];
static wchar     GlobalSystemDir[256];
static wchar     GlobalSystemDrive[20];
static wchar     GlobalTempDir[256];
static wchar     GlobalInternetCacheDir[256];
static wchar     GlobalInternetHistoryDir[256];
static wchar     GlobalCookiesDir[256];
static wchar     GlobalDesktopDir[256];
static wchar     GlobalFavoritesDir[256];
static wchar     GlobalAcrobatFileName[256];
static wchar     GlobalAcrobatFileName2[256];
static wchar     GlobalAcrobatFileName3[256];
static wchar     GlobalAcrobatFileName4[256];
static wchar     GlobalAcroOCX1FileName[256];
static wchar     GlobalAcroOCX2FileName[256];
static wchar     GlobalIEFileName[256];
static PConfig   Config = NULL;

////////////////////////////////////////////////////////////////////////////////

static void CenterDialog(HWND hdlg)
{
  SendMessage(hdlg,WM_SETICON,ICON_SMALL,(LPARAM)GlobalSmallIcon);
  SendMessage(hdlg,WM_SETICON,ICON_BIG,  (LPARAM)GlobalBigIcon);

  SetWindowPos(hdlg,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE | SWP_NOREDRAW | SWP_NOREPOSITION | SWP_NOSENDCHANGING | SWP_NOSIZE);
  SetForegroundWindow(hdlg);
  SetActiveWindow(hdlg);

  RECT R;
  GetWindowRect(hdlg,&R);
  OffsetRect(&R,-R.left,-R.top);
  int X = ((GetSystemMetrics(SM_CXSCREEN) - R.right ) / 2 + 4) & ~7;
  int Y =  (GetSystemMetrics(SM_CYSCREEN) - R.bottom) / 2;
  if (X < 0) X = 0;
  if (Y < 0) Y = 0;
  MoveWindow(hdlg,X,Y,R.right,R.bottom,FALSE);
}

typedef struct
  {
    char *qd_Descr;
    char *qd_FileName;
    char *qd_CLSID;
    bool  qd_Always;
  } TQueryData,* PQueryData;

static BOOL CALLBACK DlgProc_CLSID(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
  PQueryData QueryData;
  switch(wMsg)
    {
      case WM_INITDIALOG:
        QueryData = (PQueryData)lParam;
        if (QueryData)
          {
            SetWindowLong(hdlg,DWL_USER,(LONG)QueryData);
            CenterDialog(hdlg);
            char tmp[512],tmp1[512];
            SendDlgItemMessage(hdlg,100,WM_GETTEXT,sizeof tmp,(LPARAM)tmp);
            StringCbPrintf(tmp1,sizeof tmp1,tmp,GlobalAppName);
            SendDlgItemMessage(hdlg,100,WM_SETTEXT,0,(LPARAM)tmp1);
            SendDlgItemMessage(hdlg,200,WM_SETTEXT,0,(LPARAM)QueryData->qd_Descr);
            SendDlgItemMessage(hdlg,201,WM_SETTEXT,0,(LPARAM)QueryData->qd_FileName);
            SendDlgItemMessage(hdlg,202,WM_SETTEXT,0,(LPARAM)QueryData->qd_CLSID);
            SendDlgItemMessage(hdlg,300,BM_SETCHECK,QueryData->qd_Always,0);
            SetFocus(GetDlgItem(hdlg,2));
            return FALSE;
          }
        return TRUE;

      case WM_CLOSE:
        EndDialog(hdlg,FALSE);
        return TRUE;

      case WM_COMMAND:
        QueryData = (PQueryData)GetWindowLong(hdlg,DWL_USER);
        if (QueryData)
          QueryData->qd_Always = (bool)(SendDlgItemMessage(hdlg,300,BM_GETCHECK,0,0) != 0);
        switch(wParam)
          {
            case 1:
              EndDialog(hdlg,TRUE);
              return TRUE;

            case 2:
              EndDialog(hdlg,FALSE);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

typedef struct
  {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
  } UNICODE_STRING;
typedef struct
  {
    ULONG           oa_Length;
    HANDLE          oa_RootDirectory;
    UNICODE_STRING *oa_ObjectName;
    ULONG           oa_Attributes;
    PVOID           oa_SecurityDescriptor;
    PVOID           oa_SecurityQualityOfService;
  } TObjectAttributes,* PObjectAttributes;

typedef struct
  {
    wchar *pd_ImageFileName;
    PVOID  pd_CmdLine;
    bool   pd_Always;
  } TProcessData,* PProcessData;

static BOOL CALLBACK DlgProc_Process(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
  PProcessData ProcessData;
  switch(wMsg)
    {
      case WM_INITDIALOG:
        ProcessData = (PProcessData)lParam;
        if (ProcessData)
          {
            SetWindowLong(hdlg,DWL_USER,(LONG)ProcessData);
            CenterDialog(hdlg);
            char tmp[512],tmp1[512];
            SendDlgItemMessage(hdlg,100,WM_GETTEXT,sizeof tmp,(LPARAM)tmp);
            StringCbPrintf(tmp1,sizeof tmp1,tmp,GlobalAppName);
            SendDlgItemMessage(hdlg,100,WM_SETTEXT,0,(LPARAM)tmp1);
            SendDlgItemMessage(hdlg,300,BM_SETCHECK,ProcessData->pd_Always,0);
            SendDlgItemMessageW(hdlg,200,WM_SETTEXT,0,(LPARAM)ProcessData->pd_ImageFileName);
            UNICODE_STRING *p = (UNICODE_STRING *)ProcessData->pd_CmdLine;
            if (p && p->Length && p->Buffer)
              {
                SendDlgItemMessageW(hdlg,201,WM_SETTEXT,0,(LPARAM)p->Buffer);
              }
            SetFocus(GetDlgItem(hdlg,2));
            return FALSE;
          }
        return TRUE;

      case WM_CLOSE:
        EndDialog(hdlg,FALSE);
        return TRUE;

      case WM_COMMAND:
        ProcessData = (PProcessData)GetWindowLong(hdlg,DWL_USER);
        if (ProcessData)
          ProcessData->pd_Always = (bool)(SendDlgItemMessage(hdlg,300,BM_GETCHECK,0,0) != 0);
        switch(wParam)
          {
            case 1:
              EndDialog(hdlg,TRUE);
              return TRUE;

            case 2:
              EndDialog(hdlg,FALSE);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

typedef struct
  {
    PWSTR fd_FileName;
    uint  fd_Mode;
    ULONG fd_Access;
    bool  fd_Always;
  } TFileData,* PFileData;

static BOOL CALLBACK DlgProc_File(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
  PFileData FileData;
  switch(wMsg)
    {
      case WM_INITDIALOG:
        FileData = (PFileData)lParam;
        if (FileData)
          {
            SetWindowLong(hdlg,DWL_USER,(LONG)FileData);
            CenterDialog(hdlg);
            char tmp[512],tmp1[512];
            SendDlgItemMessage(hdlg,100,WM_GETTEXT,sizeof tmp,(LPARAM)tmp);
            StringCbPrintf(tmp1,sizeof tmp1,tmp,GlobalAppName,FileData->fd_Mode);
            SendDlgItemMessage(hdlg,100,WM_SETTEXT,0,(LPARAM)tmp1);
            SendDlgItemMessageW(hdlg,200,WM_SETTEXT,0,(LPARAM)FileData->fd_FileName);
            if (!FileData->fd_Access)
              StringCbPrintf(tmp,sizeof tmp,"<0>",FileData->fd_Access);
            else
              {
                tmp[0] = '\0';
                ULONG CurAccess = FileData->fd_Access;
                if (CurAccess & 0x00000001) { StringCbCat(tmp,sizeof tmp," READ");                   CurAccess ^= 0x00000001; }
                if (CurAccess & 0x00000002) { StringCbCat(tmp,sizeof tmp," WRITE");                  CurAccess ^= 0x00000002; }
                if (CurAccess & 0x00000004) { StringCbCat(tmp,sizeof tmp," APPEND");                 CurAccess ^= 0x00000004; }
                if (CurAccess & 0x00000008) { StringCbCat(tmp,sizeof tmp," READ_EA");                CurAccess ^= 0x00000008; }
                if (CurAccess & 0x00000010) { StringCbCat(tmp,sizeof tmp," WRITE_EA");               CurAccess ^= 0x00000010; }
                if (CurAccess & 0x00000020) { StringCbCat(tmp,sizeof tmp," EXECUTE");                CurAccess ^= 0x00000020; }
                if (CurAccess & 0x00000040) { StringCbCat(tmp,sizeof tmp," DELETE_CHILD");           CurAccess ^= 0x00000040; }
                if (CurAccess & 0x00000080) { StringCbCat(tmp,sizeof tmp," READ_ATTRIB");            CurAccess ^= 0x00000080; }
                if (CurAccess & 0x00000100) { StringCbCat(tmp,sizeof tmp," WRITE_ATTRIB");           CurAccess ^= 0x00000100; }
                if (CurAccess & 0x00010000) { StringCbCat(tmp,sizeof tmp," DELETE");                 CurAccess ^= 0x00010000; }
                if (CurAccess & 0x00020000) { StringCbCat(tmp,sizeof tmp," READ_CONTROL");           CurAccess ^= 0x00020000; }
                if (CurAccess & 0x00040000) { StringCbCat(tmp,sizeof tmp," WRITE_DAC");              CurAccess ^= 0x00040000; }
                if (CurAccess & 0x00080000) { StringCbCat(tmp,sizeof tmp," WRITE_OWNER");            CurAccess ^= 0x00080000; }
                if (CurAccess & 0x00100000) { StringCbCat(tmp,sizeof tmp," SYNCHRONIZE");            CurAccess ^= 0x00100000; }
                if (CurAccess & 0x01000000) { StringCbCat(tmp,sizeof tmp," ACCESS_SYSTEM_SECURITY"); CurAccess ^= 0x01000000; }
                if (CurAccess & 0x10000000) { StringCbCat(tmp,sizeof tmp," GENERIC_ALL");            CurAccess ^= 0x10000000; }
                if (CurAccess & 0x20000000) { StringCbCat(tmp,sizeof tmp," GENERIC_EXECUTE");        CurAccess ^= 0x20000000; }
                if (CurAccess & 0x40000000) { StringCbCat(tmp,sizeof tmp," GENERIC_WRITE");          CurAccess ^= 0x40000000; }
                if (CurAccess & 0x80000000) { StringCbCat(tmp,sizeof tmp," GENERIC_READ");           CurAccess ^= 0x80000000; }
                if (CurAccess)
                  {
                    StringCbPrintf(tmp1,sizeof tmp1," <0x%08X>",CurAccess);
                    StringCbCat(tmp,sizeof tmp,tmp1);
                  }
              }
            SendDlgItemMessage(hdlg,201,WM_SETTEXT,0,(LPARAM)tmp);
            SendDlgItemMessage(hdlg,300,BM_SETCHECK,FileData->fd_Always,0);
            SetFocus(GetDlgItem(hdlg,1));
            return FALSE;
          }
        return TRUE;

      case WM_CLOSE:
        EndDialog(hdlg,FALSE);
        return TRUE;

      case WM_COMMAND:
        FileData = (PFileData)GetWindowLong(hdlg,DWL_USER);
        if (FileData)
          FileData->fd_Always = (bool)(SendDlgItemMessage(hdlg,300,BM_GETCHECK,0,0) != 0);
        switch(wParam)
          {
            case 1:
              EndDialog(hdlg,TRUE);
              return TRUE;

            case 2:
              EndDialog(hdlg,FALSE);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

typedef struct
  {
    char *id_HostName;
    uint  id_Mode;
    bool  id_Always;
  } TINetData,* PINetData;

static BOOL CALLBACK DlgProc_INet(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
  PINetData INetData;
  switch(wMsg)
    {
      case WM_INITDIALOG:
        INetData = (PINetData)lParam;
        if (INetData)
          {
            SetWindowLong(hdlg,DWL_USER,(LONG)INetData);
            CenterDialog(hdlg);
            char tmp[512],tmp1[512];
            SendDlgItemMessage(hdlg,100,WM_GETTEXT,sizeof tmp,(LPARAM)tmp);
            StringCbPrintf(tmp1,sizeof tmp1,tmp,GlobalAppName,INetData->id_Mode);
            SendDlgItemMessage(hdlg,100,WM_SETTEXT,0,(LPARAM)tmp1);
            SendDlgItemMessage(hdlg,200,WM_SETTEXT,0,(LPARAM)INetData->id_HostName);
            SendDlgItemMessage(hdlg,300,BM_SETCHECK,INetData->id_Always,0);
            SetFocus(GetDlgItem(hdlg,1));
            return FALSE;
          }
        return TRUE;

      case WM_CLOSE:
        EndDialog(hdlg,FALSE);
        return TRUE;

      case WM_COMMAND:
        INetData = (PINetData)GetWindowLong(hdlg,DWL_USER);
        if (INetData)
          INetData->id_Always = (bool)(SendDlgItemMessage(hdlg,300,BM_GETCHECK,0,0) != 0);
        switch(wParam)
          {
            case 1:
              EndDialog(hdlg,TRUE);
              return TRUE;

            case 2:
              EndDialog(hdlg,FALSE);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

static char StatusValue_Allow[80];
static char StatusValue_Disallow[80];
static char StatusValue_Ask[80];

static void InitListView(HWND L,TConfig::TConfigCategory ConfigCategory)
{
  if (L)
    {
      SendMessage(L,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT);
      RECT R;
      GetWindowRect(L,&R);
      int ListWidth = R.right - R.left - 5;
      LVCOLUMN LVC;
      memset(&LVC,0,sizeof LVC);
      LVC.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
      char tmp[80];
      TConfig::ResLoadString(GlobalModuleHandle,strColNameActive,tmp,sizeof tmp);
      LVC.pszText = tmp;
      LVC.cx      = (ListWidth * 6) / 100;
      LVC.fmt     = LVCFMT_LEFT;
      SendMessage(L,LVM_INSERTCOLUMN,0,(LPARAM)&LVC);
      memset(&LVC,0,sizeof LVC);
      LVC.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
      TConfig::ResLoadString(GlobalModuleHandle,strColNameSetting,tmp,sizeof tmp);
      LVC.pszText = tmp;
      LVC.cx      = (ListWidth * 12) / 100;
      LVC.fmt     = LVCFMT_LEFT;
      SendMessage(L,LVM_INSERTCOLUMN,1,(LPARAM)&LVC);
      memset(&LVC,0,sizeof LVC);
      LVC.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
      switch(ConfigCategory)
        {
          case TConfig::cc_CLSID:   TConfig::ResLoadString(GlobalModuleHandle,strColNameCLSID,   tmp,sizeof tmp); break;
          case TConfig::cc_Process: TConfig::ResLoadString(GlobalModuleHandle,strColNameAppName, tmp,sizeof tmp); break;
          case TConfig::cc_File:    TConfig::ResLoadString(GlobalModuleHandle,strColNameFileName,tmp,sizeof tmp); break;
          case TConfig::cc_INet:    TConfig::ResLoadString(GlobalModuleHandle,strColNameHostName,tmp,sizeof tmp); break;
        }
      LVC.pszText = tmp;
      LVC.cx      = (ListWidth * 41) / 100;
      LVC.fmt     = LVCFMT_LEFT;
      SendMessage(L,LVM_INSERTCOLUMN,2,(LPARAM)&LVC);
      memset(&LVC,0,sizeof LVC);
      LVC.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
      TConfig::ResLoadString(GlobalModuleHandle,strColNameDescription,tmp,sizeof tmp);
      LVC.pszText = tmp;
      LVC.cx      = (ListWidth * 41) / 100;
      LVC.fmt     = LVCFMT_LEFT;
      SendMessage(L,LVM_INSERTCOLUMN,3,(LPARAM)&LVC);
    }
}

static void FillListView(HWND L,uint ListType,TConfig::TConfigCategory ConfigCategory)
{
  if (L)
    {
      SendMessage(L,LVM_DELETEALLITEMS,0,0);
      if (Config)
        {
          uint CurEntry = 0;
          for (uint Index = 0;;++Index)
            {
              wchar SubKeyNameW[1024];
              bool f = Config->ListCategory(ConfigCategory,Index,SubKeyNameW,sizeof SubKeyNameW);
              if (!f)
                break;

              uint Type     = 0;
              uint Disabled = false;
              uint State    = 0;
              char Descr[4 * 1024];
              Descr[0] = '\0';

              f = Config->GetCategorySetting(ConfigCategory,NULL,SubKeyNameW,&Type,&Disabled,&State,Descr,sizeof Descr);
              if (f)
                if (Type == ListType)
                  {
                    char tmp[80];
                    if (Disabled)
                      StringCbPrintf(tmp,sizeof tmp,"-");
                    else
                      StringCbPrintf(tmp,sizeof tmp,"+");
                    LVITEM LVI;
                    memset(&LVI,0,sizeof LVI);
                    LVI.iItem    = CurEntry;
                    LVI.iSubItem = 0;
                    LVI.mask     = LVIF_TEXT;
                    LVI.pszText  = tmp;
                    SendMessage(L,LVM_INSERTITEM,0,(LPARAM)&LVI);

                    switch(State)
                      {
                        case 0:  StringCbCopy(tmp,sizeof tmp,StatusValue_Disallow); break;
                        case 1:  StringCbCopy(tmp,sizeof tmp,StatusValue_Allow);    break;
                        case 2:  StringCbCopy(tmp,sizeof tmp,StatusValue_Ask);      break;
                        default: StringCbCopy(tmp,sizeof tmp,"???");                break;
                      }
                    memset(&LVI,0,sizeof LVI);
                    LVI.iItem    = CurEntry;
                    LVI.iSubItem = 1;
                    LVI.mask     = LVIF_TEXT;
                    LVI.pszText  = tmp;
                    SendMessage(L,LVM_SETITEM,0,(LPARAM)&LVI);

                    LVITEMW LVIW;
                    memset(&LVIW,0,sizeof LVI);
                    LVIW.iItem    = CurEntry;
                    LVIW.iSubItem = 2;
                    LVIW.mask     = LVIF_TEXT;
                    wchar Str[1024];
                    if ((ConfigCategory == TConfig::cc_Process) || (ConfigCategory == TConfig::cc_File))
                      {
                        KeyName2StrW(true,SubKeyNameW,Str,sizeof Str);
                        LVIW.pszText = Str;
                      }
                    else
                      LVIW.pszText = SubKeyNameW;
                    SendMessage(L,LVM_SETITEMW,0,(LPARAM)&LVIW);

                    memset(&LVI,0,sizeof LVI);
                    LVI.iItem    = CurEntry;
                    LVI.iSubItem = 3;
                    LVI.mask     = LVIF_TEXT;
                    LVI.pszText  = Descr;
                    SendMessage(L,LVM_SETITEM,0,(LPARAM)&LVI);
                    ++CurEntry;
                  }
            }
        }
    }
}

static char *ImportFileSignature = "# c't-IEController Import File Version 1\x0D\x0A";

static bool IsHexDigit(char c)
{
  if (('0' <= c) && (c <= '9'))
    return true;
  if (('a' <= c) && (c <= 'f'))
    return true;
  if (('A' <= c) && (c <= 'F'))
    return true;
  return false;
}

static bool ImportListView(HWND Wnd/*,HWND BlackList,HWND WhiteList*/)
{
  bool Result = false;
  char FileName[1024];
  FileName[0] = '\0';
  OPENFILENAME ofn;
  memset(&ofn,0,sizeof ofn);
  char tmp[256];
  TConfig::ResLoadString(GlobalModuleHandle,strImportFilter,tmp,sizeof tmp);
  char Filter[256];
  StringCbCopy(Filter,sizeof Filter,tmp);
  char c = Filter[strlen(Filter) - 1];
  for (uint i = 0;Filter[i];++i)
    if (Filter[i] == c)
      Filter[i] = '\0';
  ofn.lStructSize     = sizeof ofn;
  ofn.hwndOwner       = Wnd;
  ofn.lpstrFilter     = Filter;
  ofn.nFilterIndex    = 1;
  ofn.lpstrFile       = FileName;
  ofn.nMaxFile        = sizeof FileName;
  TConfig::ResLoadString(GlobalModuleHandle,strImportTitle,tmp,sizeof tmp);
  ofn.lpstrTitle      = tmp;
  ofn.lpstrInitialDir = "";
  ofn.Flags           = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
  if (GetOpenFileName(&ofn))
    {
      HANDLE F = CreateFile(FileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
      if (F != INVALID_HANDLE_VALUE)
        {
          DWORD Size = GetFileSize(F,NULL);
          if ((Size != INVALID_FILE_SIZE) && (Size < 1 * 1024 * 1024))
            {
              char *Buf = new char[Size + 1];
              if (Buf)
                {
                  DWORD R;
                  if (ReadFile(F,Buf,Size,&R,NULL) && (R == Size))
                    {
                      Buf[Size] = '\0';
                      uint l = strlen(ImportFileSignature);
                      if (!memcmp(Buf,ImportFileSignature,l))
                        {
                          char *Buf1 = Buf + l;
                          bool FormatOk = true;
                          for (uint Pass = 0;Pass < 2;++Pass)
                            {
                              uint CurLine = 2;
                              TConfig::TConfigCategory CurConfigCategory = TConfig::cc_CLSID;
                              for (char *p = Buf1;*p;++CurLine)
                                {
                                  while ((*p == ' ') || (*p == '\t'))
                                    ++p;
                                  if (*p == '#')
                                    {
                                      ++p;
                                      char *p1 = p;
                                      while (*p && (*p != '\x0D') && (*p != '\x0A'))
                                        ++p;
                                      if ((p1[0] == ' ') && (p1[1] == 'S') && (p1[2] == 'e') && (p1[3] == 'c')
                                       && (p1[4] == 't') && (p1[5] == 'i') && (p1[6] == 'o') && (p1[7] == 'n') && (p1[8] == ' '))
                                        {
                                          p1 += 9;
                                          uint l = p - p1;
                                          if      ((l == 5) && !memcmp(p1,"CLSID",   l))
                                            CurConfigCategory = TConfig::cc_CLSID;
                                          else if ((l == 7) && !memcmp(p1,"Process", l))
                                            CurConfigCategory = TConfig::cc_Process;
                                          else if ((l == 4) && !memcmp(p1,"File",    l))
                                            CurConfigCategory = TConfig::cc_File;
                                          else if ((l == 8) && !memcmp(p1,"Internet",l))
                                            CurConfigCategory = TConfig::cc_INet;
                                          else
                                            {
                                              FormatOk = false;
                                              break;
                                            }
                                        }
                                    }
                                  else if ((*p == '\x0D') || (*p == '\x0A'))
                                    {
                                    }
                                  else
                                    {
                                      uint ListType;
                                      if (*p == '1')
                                        ListType = lt_BlackList;
                                      else if (*p == '2')
                                        ListType = lt_WhiteList;
                                      else
                                        {
                                          FormatOk = false;
                                          break;
                                        }
                                      if (*++p != ',')
                                        {
                                          FormatOk = false;
                                          break;
                                        }
                                      ++p;

                                      uint Active;
                                      if (*p == '0')
                                        Active = 0;
                                      else if (*p == '1')
                                        Active = 1;
                                      else
                                        {
                                          FormatOk = false;
                                          break;
                                        }
                                      if (*++p != ',')
                                        {
                                          FormatOk = false;
                                          break;
                                        }
                                      ++p;

                                      uint State;
                                      if (*p == '0')
                                        State = 0;
                                      else if (*p == '1')
                                        State = 1;
                                      else if (*p == '2')
                                        State = 2;
                                      else
                                        {
                                          FormatOk = false;
                                          break;
                                        }
                                      if (*++p != ',')
                                        {
                                          FormatOk = false;
                                          break;
                                        }
                                      ++p;

                                      char SettingStr[1024];
                                      char SettingKey[1024];
                                      bool ValidKey = false;
                                      if (CurConfigCategory == TConfig::cc_CLSID)
                                        {
                                          if    (!IsHexDigit(p[0]) || !IsHexDigit(p[1]) || !IsHexDigit(p[2]) || !IsHexDigit(p[3]) || !IsHexDigit(p[4]) || !IsHexDigit(p[5]) || !IsHexDigit(p[6]) || !IsHexDigit(p[7])
                                              || (p[8] != '-')
                                              || !IsHexDigit(p[9]) || !IsHexDigit(p[10]) || !IsHexDigit(p[11]) || !IsHexDigit(p[12])
                                              || (p[13] != '-')
                                              || !IsHexDigit(p[14]) || !IsHexDigit(p[15]) || !IsHexDigit(p[16]) || !IsHexDigit(p[17])
                                              || (p[18] != '-')
                                              || !IsHexDigit(p[19]) || !IsHexDigit(p[20]) || !IsHexDigit(p[21]) || !IsHexDigit(p[22])
                                              || (p[23] != '-')
                                              || !IsHexDigit(p[24]) || !IsHexDigit(p[25]) || !IsHexDigit(p[26]) || !IsHexDigit(p[27]) || !IsHexDigit(p[28]) || !IsHexDigit(p[29]) || !IsHexDigit(p[30]) || !IsHexDigit(p[31]) || !IsHexDigit(p[32]) || !IsHexDigit(p[33]) || !IsHexDigit(p[34]) || !IsHexDigit(p[35]))
                                            {
                                              FormatOk = false;
                                              break;
                                            }
                                          memcpy(SettingStr,p,36);
                                          SettingStr[36] = '\0';
                                          p += 36;
                                        }
                                      else
                                        {
                                          if (*p != '"')
                                            {
                                              FormatOk = false;
                                              break;
                                            }
                                          ++p;
                                          char *p1 = SettingStr;
                                          while (*p && (*p != '"'))
                                            {
                                              if ((p1 - SettingStr) < (sizeof SettingStr - 1))
                                                *p1++ = *p;
                                              ++p;
                                            }
                                          *p1 = '\0';
                                          if (*p)
                                            ++p;

                                          if ((CurConfigCategory == TConfig::cc_Process) || (CurConfigCategory == TConfig::cc_File))
                                            {
                                              Str2KeyName(true,SettingStr,SettingKey,sizeof SettingKey);
                                              ValidKey = true;
                                            }
                                        }
                                      if (*p != ',')
                                        {
                                          FormatOk = false;
                                          break;
                                        }
                                      ++p;

                                      char Descr[4 * 1024];
                                      char *p1 = Descr;
                                      while (*p && (*p != '\x0D') && (*p != '\x0A'))
                                        {
                                          if ((p1 - Descr) < (sizeof Descr - 1))
                                            *p1++ = *p;
                                          ++p;
                                        }
                                      *p1 = '\0';
                                      if (FormatOk && (Pass > 0))
                                        if (Config)
                                          Config->SetCategorySetting(CurConfigCategory,ValidKey ? SettingKey : SettingStr,NULL,true,ListType,true,!Active,true,State,true,Descr);
                                    }
                                  if (*p == '\x0D')
                                    ++p;
                                  if (*p == '\x0A')
                                    ++p;
                                }
                              if (!FormatOk)
                                {
                                  char tmp1[80];
                                  TConfig::ResLoadString(GlobalModuleHandle,strInvalidImportFormat,tmp1,sizeof tmp1);
                                  StringCbPrintf(tmp,sizeof tmp,tmp1,CurLine);
                                  AlertMsg(tmp);
                                  break;
                                }
                            }
                          if (FormatOk)
                            Result = true;
                        }
                      else
                        {
                          TConfig::ResLoadString(GlobalModuleHandle,strInvalidImportSignature,tmp,sizeof tmp);
                          AlertMsg(tmp);
                        }
                    }
                  delete [] Buf;
                }
            }
          CloseHandle(F);
        }
    }
  return Result;
}

typedef struct
  {
    TConfig::TConfigCategory es_Category;
    HWND                     es_List;
    TListType                es_ListType;
    int                      es_Index;
  } TEntrySpecifier,* PEntrySpecifier;

static BOOL CALLBACK DlgProc_EditSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
  PEntrySpecifier EntrySpecifier;
  char tmp[4 * 1024],tmp1[4 * 1024],tmp2[256];
  switch(wMsg)
    {
      case WM_INITDIALOG:
        EntrySpecifier = (PEntrySpecifier)lParam;
        if (EntrySpecifier)
          {
            SetWindowLong(hdlg,DWL_USER,(LONG)EntrySpecifier);
            CenterDialog(hdlg);

            TConfig::ResLoadString(GlobalModuleHandle,strColNameSetting,tmp,sizeof tmp);
            StringCbCat(tmp,sizeof tmp,":");
            SendDlgItemMessage(hdlg,70,WM_SETTEXT,0,(LPARAM)tmp);
            switch(EntrySpecifier->es_Category)
              {
                case TConfig::cc_CLSID:   TConfig::ResLoadString(GlobalModuleHandle,strColNameCLSID,   tmp,sizeof tmp); break;
                case TConfig::cc_Process: TConfig::ResLoadString(GlobalModuleHandle,strColNameAppName, tmp,sizeof tmp); break;
                case TConfig::cc_File:    TConfig::ResLoadString(GlobalModuleHandle,strColNameFileName,tmp,sizeof tmp); break;
                case TConfig::cc_INet:    TConfig::ResLoadString(GlobalModuleHandle,strColNameHostName,tmp,sizeof tmp); break;
              }
            StringCbCat(tmp,sizeof tmp,":");
            SendDlgItemMessage(hdlg,71,WM_SETTEXT,0,(LPARAM)tmp);

            if (EntrySpecifier->es_Category == TConfig::cc_CLSID)
              if (!(EntrySpecifier->es_Index < 0))
                SendDlgItemMessage(hdlg,10,EM_SETREADONLY,TRUE,0);

            if (EntrySpecifier->es_Index < 0)
              {
                SendDlgItemMessage(hdlg,20,BM_SETCHECK,TRUE,0);
                if (EntrySpecifier->es_ListType == lt_BlackList)
                  SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)StatusValue_Disallow);
                else
                  {
                    SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)StatusValue_Allow);
                    SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)StatusValue_Ask);
                    SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)StatusValue_Disallow);
                  }
                SendDlgItemMessage(hdlg,30,CB_SETCURSEL,0,0);
              }
            else
              {
                LVITEM I;
                memset(&I,0,sizeof I);
                I.mask       = LVIF_TEXT;
                I.iItem      = EntrySpecifier->es_Index;
                I.iSubItem   = 1;
                I.pszText    = tmp;
                I.cchTextMax = sizeof tmp;
                if (SendMessage(EntrySpecifier->es_List,LVM_GETITEM,0,(LPARAM)&I))
                  {
                    if (EntrySpecifier->es_ListType == lt_BlackList)
                      {
                        SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)tmp);
                        SendDlgItemMessage(hdlg,30,CB_SETCURSEL,0,0);
                      }
                    else
                      {
                        SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)StatusValue_Allow);
                        SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)StatusValue_Ask);
                        SendDlgItemMessage(hdlg,30,CB_ADDSTRING,0,(LPARAM)StatusValue_Disallow);
                        if (!strcmp(tmp,StatusValue_Allow))
                          SendDlgItemMessage(hdlg,30,CB_SETCURSEL,0,0);
                        else if (!strcmp(tmp,StatusValue_Ask))
                          SendDlgItemMessage(hdlg,30,CB_SETCURSEL,1,0);
                        else if (!strcmp(tmp,StatusValue_Disallow))
                          SendDlgItemMessage(hdlg,30,CB_SETCURSEL,2,0);
                        else
                          SendDlgItemMessage(hdlg,30,CB_SETCURSEL,(WPARAM)-1,0);
                      }
                  }

                memset(&I,0,sizeof I);
                I.mask       = LVIF_TEXT;
                I.iItem      = EntrySpecifier->es_Index;
                I.iSubItem   = 2;
                I.pszText    = tmp;
                I.cchTextMax = sizeof tmp;
                if (SendMessage(EntrySpecifier->es_List,LVM_GETITEM,0,(LPARAM)&I))
                  SendDlgItemMessage(hdlg,10,WM_SETTEXT,0,(LPARAM)tmp);

                memset(&I,0,sizeof I);
                I.mask       = LVIF_TEXT;
                I.iItem      = EntrySpecifier->es_Index;
                I.iSubItem   = 0;
                I.pszText    = tmp;
                I.cchTextMax = sizeof tmp;
                if (SendMessage(EntrySpecifier->es_List,LVM_GETITEM,0,(LPARAM)&I))
                  SendDlgItemMessage(hdlg,20,BM_SETCHECK,tmp[0] == '+',0);

                memset(&I,0,sizeof I);
                I.mask       = LVIF_TEXT;
                I.iItem      = EntrySpecifier->es_Index;
                I.iSubItem   = 3;
                I.pszText    = tmp;
                I.cchTextMax = sizeof tmp;
                if (SendMessage(EntrySpecifier->es_List,LVM_GETITEM,0,(LPARAM)&I))
                  SendDlgItemMessage(hdlg,40,WM_SETTEXT,0,(LPARAM)tmp);
              }
          }
        SetFocus(GetDlgItem(hdlg,1));
        return FALSE;

      case WM_CLOSE:
        EndDialog(hdlg,FALSE);
        return TRUE;

      case WM_COMMAND:
        switch(wParam)
          {
            case 1:
              EntrySpecifier = (PEntrySpecifier)GetWindowLong(hdlg,DWL_USER);
              if (EntrySpecifier && Config)
                {
                  if (SendDlgItemMessage(hdlg,10,WM_GETTEXT,sizeof tmp,(LPARAM)tmp))
                    {
                      if ((EntrySpecifier->es_Category == TConfig::cc_Process) || (EntrySpecifier->es_Category == TConfig::cc_File))
                        {
                          Str2KeyName(true,tmp,tmp1,sizeof tmp1);
                          StringCbCopy(tmp,sizeof tmp,tmp1);
                        }

                      bool Active     = (bool)(SendDlgItemMessage(hdlg,20,BM_GETCHECK,0,0) != 0);
                      bool StateValid = true;
                      uint State      = 0;
                      bool ValidType  = true;
                      uint Type       = EntrySpecifier->es_ListType;
                      if (EntrySpecifier->es_ListType == lt_WhiteList)
                        {
                          switch(SendDlgItemMessage(hdlg,30,CB_GETCURSEL,0,0))
                            {
                              case 0:
                                State = 1;
                                break;

                              case 1:
                                State = 2;
                                break;

                              case 2:
                                TConfig::ResLoadString(GlobalModuleHandle,strTypeChangeConfirmation,tmp2,sizeof tmp2);
                                if (MessageBox(hdlg,tmp2,APPNAME,MB_YESNO | MB_DEFBUTTON2 | MB_SYSTEMMODAL) == IDYES)
                                  {
                                    State = 0;
                                    Type  = lt_BlackList;
                                  }
                                else
                                  StateValid = false;
                                break;
                            }
                        }
                      bool DescrValid = false;
                      if (SendDlgItemMessage(hdlg,40,WM_GETTEXT,sizeof tmp1,(LPARAM)tmp1))
                        DescrValid = true;
                      Config->SetCategorySetting(EntrySpecifier->es_Category,tmp,NULL,ValidType,Type,true,!Active,StateValid,State,DescrValid,tmp1);
                    }
                }
              EndDialog(hdlg,TRUE);
              return TRUE;

            case 2:
              EndDialog(hdlg,FALSE);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

static BOOL CALLBACK DlgProc_ExpertSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
  TConfig::TConfigCategory ConfigCategory;
  switch(wMsg)
    {
      case WM_INITDIALOG:
        ConfigCategory = (TConfig::TConfigCategory)lParam;
        SetWindowLong(hdlg,DWL_USER,(LONG)ConfigCategory);
        CenterDialog(hdlg);
        if (Config)
          {
            HWND L = GetDlgItem(hdlg,10);
            if (L)
              {
                InitListView(L,ConfigCategory);
                FillListView(L,lt_BlackList,ConfigCategory);
              }
            L = GetDlgItem(hdlg,20);
            if (L)
              {
                InitListView(L,ConfigCategory);
                FillListView(L,lt_WhiteList,ConfigCategory);
              }

            uint DefaultAction = 0;
            switch(ConfigCategory)
              {
                case TConfig::cc_CLSID:   DefaultAction = Config->GetGlobalSetting(TConfig::st_COMDefaultAction,0);  break;
                case TConfig::cc_Process: DefaultAction = Config->GetGlobalSetting(TConfig::st_AppDefaultAction,2);  break;
                case TConfig::cc_File:    DefaultAction = Config->GetGlobalSetting(TConfig::st_FileDefaultAction,1); break;
                case TConfig::cc_INet:    DefaultAction = Config->GetGlobalSetting(TConfig::st_INetDefaultAction,1); break;
              }
            switch(DefaultAction)
              {
                default:
                case 0: SendDlgItemMessage(hdlg,200,BM_SETCHECK,TRUE,0); break;
                case 1: SendDlgItemMessage(hdlg,201,BM_SETCHECK,TRUE,0); break;
                case 2: SendDlgItemMessage(hdlg,202,BM_SETCHECK,TRUE,0); break;
              }
          }
        SetFocus(GetDlgItem(hdlg,1));
        return FALSE;

      case WM_CLOSE:
        EndDialog(hdlg,FALSE);
        return TRUE;

      case WM_COMMAND:
        ConfigCategory = (TConfig::TConfigCategory)GetWindowLong(hdlg,DWL_USER);
        switch(wParam)
          {
            case 1:
              if (Config)
                {
                  TConfig::TSettingType SettingType = TConfig::st_unknown;
                  switch(ConfigCategory)
                    {
                      case TConfig::cc_CLSID:   SettingType = TConfig::st_COMDefaultAction;  break;
                      case TConfig::cc_Process: SettingType = TConfig::st_AppDefaultAction;  break;
                      case TConfig::cc_File:    SettingType = TConfig::st_FileDefaultAction; break;
                      case TConfig::cc_INet:    SettingType = TConfig::st_INetDefaultAction; break;
                    }

                  uint x = (SendDlgItemMessage(hdlg,200,BM_GETCHECK,0,0) != 0);
                  if (x)
                    Config->SetGlobalSetting(SettingType,0);
                  else
                    {
                      x = (SendDlgItemMessage(hdlg,201,BM_GETCHECK,0,0) != 0);
                      if (x)
                        Config->SetGlobalSetting(SettingType,1);
                      else
                        {
                          x = (SendDlgItemMessage(hdlg,202,BM_GETCHECK,0,0) != 0);
                          if (x)
                            Config->SetGlobalSetting(SettingType,2);
                        }
                    }
                }
              EndDialog(hdlg,TRUE);
              return TRUE;

            case 2:
              EndDialog(hdlg,FALSE);
              return TRUE;
          }
        break;

      case WM_NOTIFY:
        ConfigCategory = (TConfig::TConfigCategory)GetWindowLong(hdlg,DWL_USER);
        {
          LPNMHDR N = (LPNMHDR)lParam;
          if (N)
            {
              HWND BlackList = GetDlgItem(hdlg,10);
              HWND WhiteList = GetDlgItem(hdlg,20);
              HWND CurList   = NULL;
              TListType ListType = lt_unknown;
              if (N->hwndFrom == BlackList)
                {
                  ListType = lt_BlackList;
                  CurList  = BlackList;
                }
              else if (N->hwndFrom == WhiteList)
                {
                  ListType = lt_WhiteList;
                  CurList  = WhiteList;
                }
              if (ListType != lt_unknown)
                {
                  switch(N->code)
                    {
                      case NM_DBLCLK:
                        {
                          NMITEMACTIVATE *IA = (NMITEMACTIVATE *)lParam;
                          if (IA)
                            {
                              if (IA->iItem >= 0)
                                {
                                  TEntrySpecifier ES;
                                  memset(&ES,0,sizeof ES);
                                  ES.es_Category = ConfigCategory;
                                  ES.es_List     = CurList;
                                  ES.es_ListType = ListType;
                                  ES.es_Index    = IA->iItem;
                                  if (DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,12),hdlg,DlgProc_EditSettings,(LPARAM)&ES) == TRUE)
                                    {
                                      FillListView(BlackList,lt_BlackList,ConfigCategory);
                                      FillListView(WhiteList,lt_WhiteList,ConfigCategory);
                                    }
                                }
                            }
                        }
                        break;

                      case NM_RCLICK:
                        {
                          POINT P;
                          GetCursorPos(&P);
                          LVHITTESTINFO HTI;
                          memset(&HTI,0,sizeof HTI);
                          HTI.pt    = P;
                          HTI.flags = TVHT_ONITEM;
                          ScreenToClient(CurList,&HTI.pt);
                          int CurIndex = SendMessage(CurList,LVM_HITTEST,0,(LPARAM)&HTI);
                          HMENU SubMenu = GetSubMenu(GlobalPopupMenu,0);
                          if (SubMenu)
                            {
                              EnableMenuItem(SubMenu,1001,(CurIndex < 0) ? MF_GRAYED : MF_ENABLED);
                              EnableMenuItem(SubMenu,1002,(CurIndex < 0) ? MF_GRAYED : MF_ENABLED);
                              DWORD MenuId = TrackPopupMenu(SubMenu,TPM_LEFTALIGN | TPM_NONOTIFY | TPM_RETURNCMD,(int)P.x,(int)P.y,0,hdlg,NULL);
                              if (MenuId)
                                {
                                  switch(MenuId)
                                    {
                                      case 1000:
                                        {
                                          TEntrySpecifier ES;
                                          memset(&ES,0,sizeof ES);
                                          ES.es_Category = ConfigCategory;
                                          ES.es_List     = CurList;
                                          ES.es_ListType = ListType;
                                          ES.es_Index    = -1;
                                          DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,12),hdlg,DlgProc_EditSettings,(LPARAM)&ES);
                                        }
                                        break;

                                      case 1001:
                                        {
                                          TEntrySpecifier ES;
                                          memset(&ES,0,sizeof ES);
                                          ES.es_Category = ConfigCategory;
                                          ES.es_List     = CurList;
                                          ES.es_ListType = ListType;
                                          ES.es_Index    = CurIndex;
                                          DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,12),hdlg,DlgProc_EditSettings,(LPARAM)&ES);
                                        }
                                        break;

                                      case 1002:
                                        if (CurIndex >= 0)
                                          {
                                            wchar tmp[512];
                                            char  tmp1[1024],tmp2[256];
                                            LVITEMW I;
                                            memset(&I,0,sizeof I);
                                            I.mask       = LVIF_TEXT;
                                            I.iItem      = CurIndex;
                                            I.iSubItem   = 2;
                                            I.pszText    = tmp;
                                            I.cchTextMax = sizeof tmp / sizeof tmp[0];
                                            if (SendMessage(CurList,LVM_GETITEMW,0,(LPARAM)&I))
                                              {
                                                TConfig::ResLoadString(GlobalModuleHandle,strDeleteConfirmation,tmp2,sizeof tmp2);
                                                StringCbPrintf(tmp1,sizeof tmp1,tmp2,tmp);
                                                if (MessageBox(hdlg,tmp1,APPNAME,MB_YESNO | MB_DEFBUTTON2 | MB_SYSTEMMODAL) == IDYES)
                                                  {
                                                    if ((ConfigCategory == TConfig::cc_Process) || (ConfigCategory == TConfig::cc_File))
                                                      {
                                                        wchar Key[512];
                                                        Str2KeyNameW(true,tmp,Key,sizeof Key);
                                                        Config->DeleteCategorySetting(ConfigCategory,NULL,Key);
                                                      }
                                                    else
                                                      Config->DeleteCategorySetting(ConfigCategory,NULL,tmp);
                                                  }
                                              }
                                          }
                                        break;
                                    }
                                  FillListView(BlackList,lt_BlackList,ConfigCategory);
                                  FillListView(WhiteList,lt_WhiteList,ConfigCategory);
                                }
                            }
                        }
                        break;
                    }
                }
            }
        }
        break;
    }
  return FALSE;
}

static bool CreateDesktopShortCut(char *LinkName,char *LinkDestFileName,char *Arguments)
{
  bool Result = false;
  if (LinkName && LinkName[0] && LinkDestFileName && LinkDestFileName[0])
    {
      HKEY Key = 0;
      if (RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",0,KEY_QUERY_VALUE,&Key) == ERROR_SUCCESS)
        {
          DWORD ValueType;
          CHAR  DesktopFileName[1024];
          DWORD ValueSize = sizeof DesktopFileName;
          if (RegQueryValueEx(Key,"Desktop",NULL,&ValueType,(LPBYTE)DesktopFileName,&ValueSize) == ERROR_SUCCESS)
            if (ValueType == REG_SZ)
              {
                StringCbCat(DesktopFileName,sizeof DesktopFileName,"\\");
                StringCbCat(DesktopFileName,sizeof DesktopFileName,LinkName);
                StringCbCat(DesktopFileName,sizeof DesktopFileName,".lnk");

                bool ComInit = false;
                IShellLink *ShellLink;
                HRESULT hres = CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(LPVOID *)&ShellLink);
                if (hres == CO_E_NOTINITIALIZED)
                  {
                    CoInitialize(NULL);
                    ComInit = true;
                    hres = CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(LPVOID *)&ShellLink);
                  }
                if (!SUCCEEDED(hres))
                  {
                    char tmp[256],tmp1[128];
                    TConfig::ResLoadString(GlobalModuleHandle,strErrorCreatingShortcut,tmp1,sizeof tmp1);
                    StringCbPrintf(tmp,sizeof tmp,tmp1,hres);
                    AlertMsg(tmp);
                  }
                else
                  {
                    if (SUCCEEDED(ShellLink->SetPath(LinkDestFileName)))
                      {
                        if (Arguments)
                          ShellLink->SetArguments(Arguments);

                        IPersistFile *PersistFile;
                        if (SUCCEEDED(ShellLink->QueryInterface(IID_IPersistFile,(LPVOID *)&PersistFile)))
                          {
                            WORD wsz[MAX_PATH];
                            MultiByteToWideChar(CP_ACP,0,DesktopFileName,-1,wsz,MAX_PATH);
                            if (SUCCEEDED(PersistFile->Save(wsz,TRUE)))
                              {
                                Result = true;
                              }
                            PersistFile->Release();
                          }
                      }
                    ShellLink->Release();
                  }
                if (ComInit)
                  CoUninitialize();
              }
          RegCloseKey(Key);
        }
    }
  return Result;
}

static BOOL CALLBACK DlgProc_CfgSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM /*lParam*/)
{
  char tmp[1024],tmp1[1024];
  switch(wMsg)
    {
      case WM_INITDIALOG:
        if (Config)
          {
            SendDlgItemMessage(hdlg,10,WM_SETTEXT,0,(LPARAM)GlobalAppName);
            SendDlgItemMessage(hdlg,20,WM_SETTEXT,0,(LPARAM)GlobalCfgName);
          }
        return TRUE;

      case WM_COMMAND:
        switch(wParam)
          {
            case 97:
              {
                StringCbCopy(tmp,sizeof tmp,"-Cfg:");
                StringCbCat(tmp,sizeof tmp,GlobalCfgName);
                if (GetBrowserExecutableName(tmp1,sizeof tmp1))
                  {
                    StringCbCat(tmp,sizeof tmp," -App:\"");
                    StringCbCat(tmp,sizeof tmp,tmp1);
                    StringCbCat(tmp,sizeof tmp,"\"");

                    StringCbCat(tmp,sizeof tmp," \"");
                    StringCbCat(tmp,sizeof tmp,"http://www.heise.de/ct/ftp/projekte/iecontroller/");
                    StringCbCat(tmp,sizeof tmp,"\"");

                    STARTUPINFO SI;
                    memset(&SI,0,sizeof SI);
                    SI.cb      = sizeof SI;
                    SI.dwFlags = 0;
                    PROCESS_INFORMATION PI;
                    memset(&PI,0,sizeof PI);
                    if (CreateProcess(GlobalLauncherFileName,tmp,NULL,NULL,FALSE,0,NULL,NULL,&SI,&PI))
                      {
                        CloseHandle(PI.hThread);
                        CloseHandle(PI.hProcess);
                      }
                  }
              }
              return TRUE;

            case 98:
              {
                if (!ImportListView(hdlg))
                  {
                    TConfig::ResLoadString(GlobalModuleHandle,strImportError,tmp,sizeof tmp);
                    AlertMsg(tmp);
                  }
                else
                  {
                    TConfig::ResLoadString(GlobalModuleHandle,strImportOk,tmp,sizeof tmp);
                    AlertMsg(tmp,true);
                  }
              }
              return TRUE;

            case 99:
              if (Config)
                {
                  char CfgName[80];
                  if (!SendDlgItemMessage(hdlg,20,WM_GETTEXT,sizeof CfgName,(LPARAM)CfgName))
                    CfgName[0] = '\0';

                  uint l = strlen(CfgName);
                  bool NameOk = true;
                  for (uint i = 0;i < l;++i)
                    {
                      char c = CfgName[i];
                      if (!((('0' <= c) && (c <= '9')) || (('a' <= c) && (c <= 'z')) || (('A' <= c) && (c <= 'Z'))))
                        {
                          NameOk = false;
                          break;
                        }
                    }
                  if (!NameOk)
                    {
                      char tmp1[128];
                      TConfig::ResLoadString(GlobalModuleHandle,strInvalidCfgName,tmp1,sizeof tmp1);
                      StringCbPrintf(tmp,sizeof tmp,tmp1,CfgName);
                      AlertMsg(tmp);
                    }
                  else
                    {
                      bool IsOk = false;
                      if (Config->Clone(GlobalConfigKeyName,CfgName))
                        {
                          PConfig Config1 = new TConfig(GlobalConfigKeyName,CfgName,(GlobalPatchFlags & pf_ROConfig) != 0,(GlobalPatchFlags & pf_GlobalConfig) != 0);
                          if (Config1 && Config->ConfigOk)
                            {
                              StringCbCopy(GlobalCfgName,sizeof GlobalCfgName,CfgName);
                              PConfig ConfigOld = Config;
                              Config = Config1;
                              delete ConfigOld;

                              char LinkName[256];
                              StringCbCopy(LinkName,sizeof LinkName,"c't-IEController");
                              StringCbCat(LinkName,sizeof LinkName," ");
                              StringCbCat(LinkName,sizeof LinkName,CfgName);

                              char Args[256];
                              StringCbCopy(Args,sizeof Args,"-Cfg:");
                              StringCbCat(Args,sizeof Args,CfgName);
                              CreateDesktopShortCut(LinkName,GlobalLauncherFileName,Args);

                              char tmp1[128];
                              if (!CfgName[0])
                                {
                                  TConfig::ResLoadString(GlobalModuleHandle,strDefCfgSaved,tmp1,sizeof tmp1);
                                  StringCbPrintf(tmp,sizeof tmp,tmp1);
                                }
                              else
                                {
                                  TConfig::ResLoadString(GlobalModuleHandle,strCfgSaved,tmp1,sizeof tmp1);
                                  StringCbPrintf(tmp,sizeof tmp,tmp1,CfgName);
                                }
                              AlertMsg(tmp,true);
                              IsOk = true;
                            }
                        }
                      if (!IsOk)
                        {
                          char tmp1[128];
                          TConfig::ResLoadString(GlobalModuleHandle,strErrorSavingCfg,tmp1,sizeof tmp1);
                          StringCbPrintf(tmp,sizeof tmp,tmp1,CfgName);
                          AlertMsg(tmp);
                        }
                    }
                }
              return TRUE;
          }
        break;
    }
  return FALSE;
}

static BOOL CALLBACK DlgProc_COMSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM /*lParam*/)
{
  switch(wMsg)
    {
      case WM_INITDIALOG:
        if (Config)
          {
            SendDlgItemMessage(hdlg,200,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedIEDefaults,   true), 0);
            SendDlgItemMessage(hdlg,201,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedJScript,      false),0);
            SendDlgItemMessage(hdlg,202,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedVBScript,     false),0);
            SendDlgItemMessage(hdlg,203,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedJava,         false),0);
            SendDlgItemMessage(hdlg,204,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false),0);
            SendDlgItemMessage(hdlg,205,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFlash,        false),0);
            SendDlgItemMessage(hdlg,206,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedPNG,          false),0);
          }
        return TRUE;

      case WM_COMMAND:
        switch(wParam)
          {
            case 98:
              DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,201),hdlg,DlgProc_ExpertSettings,(LPARAM)TConfig::cc_CLSID);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

static BOOL CALLBACK DlgProc_PrgmSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM /*lParam*/)
{
  switch(wMsg)
    {
      case WM_INITDIALOG:
        if (Config)
          {
            SendDlgItemMessage(hdlg,200,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedProcNotepad,   true), 0);
            SendDlgItemMessage(hdlg,201,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,  false),0);
            SendDlgItemMessage(hdlg,202,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedProcWMPlayer,  false),0);
            SendDlgItemMessage(hdlg,203,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedProcRealPlayer,false),0);
            SendDlgItemMessage(hdlg,204,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedProcWord,      false),0);
            SendDlgItemMessage(hdlg,205,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedProcExcel,     false),0);
            SendDlgItemMessage(hdlg,206,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedProcPowerPoint,false),0);
          }
        return TRUE;

      case WM_COMMAND:
        switch(wParam)
          {
            case 98:
              DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,202),hdlg,DlgProc_ExpertSettings,(LPARAM)TConfig::cc_Process);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

static BOOL CALLBACK DlgProc_FilesSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM /*lParam*/)
{
  switch(wMsg)
    {
      case WM_INITDIALOG:
        if (Config)
          {
            SendDlgItemMessage(hdlg,200,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFileSystemRead,    true),0);
            SendDlgItemMessage(hdlg,201,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFileBrowserCache,  true),0);
            SendDlgItemMessage(hdlg,202,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFileBrowserHistory,true),0);
            SendDlgItemMessage(hdlg,203,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFileTemp,          true),0);
            SendDlgItemMessage(hdlg,204,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFileCookies,       true),0);
            SendDlgItemMessage(hdlg,205,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFileDesktop,       true),0);
            SendDlgItemMessage(hdlg,206,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedFileFavorites,     true),0);
          }
        return TRUE;

      case WM_COMMAND:
        switch(wParam)
          {
            case 98:
              DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,203),hdlg,DlgProc_ExpertSettings,(LPARAM)TConfig::cc_File);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

static BOOL CALLBACK DlgProc_INetSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM /*lParam*/)
{
  switch(wMsg)
    {
      case WM_INITDIALOG:
        if (Config)
          {
            SendDlgItemMessage(hdlg,200,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedServerRelLinks,false),0);
            SendDlgItemMessage(hdlg,201,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedServerAds,     false),0);
            SendDlgItemMessage(hdlg,240,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_AllowedIP,            true), 0);
            SendDlgItemMessage(hdlg,250,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_DisableVeriSign,      true), 0);
            SendDlgItemMessage(hdlg,290,BM_SETCHECK,Config->GetGlobalSetting(TConfig::st_LogData,              false),0);
          }
        return TRUE;

      case WM_COMMAND:
        switch(wParam)
          {
            case 98:
              DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,204),hdlg,DlgProc_ExpertSettings,(LPARAM)TConfig::cc_INet);
              return TRUE;
          }
        break;
    }
  return FALSE;
}

const uint TabCount = 5;
static HWND PageCtrl[TabCount];
const uint DefaultTab = 1;

static BOOL CALLBACK DlgProc_GlobalSettings(HWND hdlg,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
  switch(wMsg)
    {
      case WM_INITDIALOG:
        SetWindowLong(hdlg,DWL_USER,(LONG)lParam);
        if (lParam == 1)
          {
            char tmp[80];
            TConfig::ResLoadString(GlobalModuleHandle,strButtonContinue,tmp,sizeof tmp);
            SendDlgItemMessage(hdlg,1,WM_SETTEXT,0,(LPARAM)tmp);
          }
        CenterDialog(hdlg);
        if (Config)
          {
            static DLGPROC TabDlg[TabCount] =
              {
                DlgProc_CfgSettings,
                DlgProc_COMSettings,
                DlgProc_PrgmSettings,
                DlgProc_FilesSettings,
                DlgProc_INetSettings
              };
            memset(PageCtrl,0,sizeof PageCtrl);
            for (uint i = 0;i < TabCount;++i)
              {
                TCITEM TCI;
                memset(&TCI,0,sizeof TCI);
                TCI.mask   |= TCIF_TEXT;
                char TabName[80];
                switch(i)
                  {
                    case 0:  TConfig::ResLoadString(GlobalModuleHandle,strTabNameCfg,  TabName,sizeof TabName); break;
                    case 1:  TConfig::ResLoadString(GlobalModuleHandle,strTabNameCOM,  TabName,sizeof TabName); break;
                    case 2:  TConfig::ResLoadString(GlobalModuleHandle,strTabNamePrgm, TabName,sizeof TabName); break;
                    case 3:  TConfig::ResLoadString(GlobalModuleHandle,strTabNameFiles,TabName,sizeof TabName); break;
                    case 4:  TConfig::ResLoadString(GlobalModuleHandle,strTabNameINet, TabName,sizeof TabName); break;
                    default: TabName[0] = '\0'; break;
                  }
                TCI.pszText = TabName;
                TCI.iImage  = -1;
                SendDlgItemMessage(hdlg,900,TCM_INSERTITEM,i,(LPARAM)&TCI);
                PageCtrl[i] = CreateDialog(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,100 + i),hdlg,TabDlg[i]);
                if (i == DefaultTab)
                  ShowWindow(PageCtrl[i],SW_SHOW);
              }
            SendDlgItemMessage(hdlg,900,TCM_SETCURSEL,DefaultTab,NULL);
          }
        SetFocus(GetDlgItem(hdlg,1));
        return FALSE;

      case WM_NOTIFY:
        if (lParam)
          {
            NMHDR *pnmh = (NMHDR*)lParam;
            if (pnmh->code == TCN_SELCHANGE)
              {
                uint Index = SendDlgItemMessage(hdlg,900,TCM_GETCURSEL,0,0);
                for (uint i = 0;i < TabCount;++i)
                  ShowWindow(PageCtrl[i],SW_HIDE);
                if ((Index >= 0) && (Index < TabCount))
                  ShowWindow(PageCtrl[Index],SW_SHOW);
              }
          }
        break;

      case WM_CLOSE:
        EndDialog(hdlg,FALSE);
        ExitProcess(998);

      case WM_COMMAND:
        switch(wParam)
          {
            case 1:
              if (Config)
                {
                  uint x;
                  HWND W = PageCtrl[1];
                  if (W)
                    {
                      x = (SendDlgItemMessage(W,200,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedIEDefaults,x);
                      x = (SendDlgItemMessage(W,201,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedJScript,x);
                      x = (SendDlgItemMessage(W,202,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedVBScript,x);
                      x = (SendDlgItemMessage(W,203,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedJava,x);
                      x = (SendDlgItemMessage(W,204,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedAcrobatReader,x);
                      x = (SendDlgItemMessage(W,205,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFlash,x);
                      x = (SendDlgItemMessage(W,206,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedPNG,x);
                    }
                  W = PageCtrl[2];
                  if (W)
                    {
                      x = (SendDlgItemMessage(W,200,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedProcNotepad,x);
                      x = (SendDlgItemMessage(W,201,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedProcAcroRd32,x);
                      x = (SendDlgItemMessage(W,202,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedProcWMPlayer,x);
                      x = (SendDlgItemMessage(W,203,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedProcRealPlayer,x);
                      x = (SendDlgItemMessage(W,204,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedProcWord,x);
                      x = (SendDlgItemMessage(W,205,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedProcExcel,x);
                      x = (SendDlgItemMessage(W,206,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedProcPowerPoint,x);
                    }
                  W = PageCtrl[3];
                  if (W)
                    {
                      x = (SendDlgItemMessage(W,200,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFileSystemRead,x);
                      x = (SendDlgItemMessage(W,201,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFileBrowserCache,x);
                      x = (SendDlgItemMessage(W,202,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFileBrowserHistory,x);
                      x = (SendDlgItemMessage(W,203,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFileTemp,x);
                      x = (SendDlgItemMessage(W,204,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFileCookies,x);
                      x = (SendDlgItemMessage(W,205,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFileDesktop,x);
                      x = (SendDlgItemMessage(W,206,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedFileFavorites,x);
                    }
                  W = PageCtrl[4];
                  if (W)
                    {
                      x = (SendDlgItemMessage(W,200,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedServerRelLinks,x);
                      x = (SendDlgItemMessage(W,201,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedServerAds,x);
                      x = (SendDlgItemMessage(W,240,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_AllowedIP,x);
                      x = (SendDlgItemMessage(W,250,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_DisableVeriSign,x);
                      x = (SendDlgItemMessage(W,290,BM_GETCHECK,0,0) != 0);
                      Config->SetGlobalSetting(TConfig::st_LogData,x);
                    }
                }
              EndDialog(hdlg,TRUE);
              return TRUE;

            case 2:
              if (GetWindowLong(hdlg,DWL_USER) == 1)
                {
                  EndDialog(hdlg,FALSE);
                  return TRUE;
                }

            case 92:
              EndDialog(hdlg,FALSE);
              ExitProcess(999);
          }
        break;
    }
  return FALSE;
}

static void CheckDefaultConfig(void)
{
  static bool IsSet = false;
  if (!IsSet)
    {
      IsSet = true;
      uint DefaultsSet = false;
      if (Config)
        DefaultsSet = Config->GetGlobalSetting(TConfig::st_DefaultsSet,false);
      if ((GlobalPatchFlags & pf_ForceConfig) || !DefaultsSet)
        {
          GlobalPatchFlags &= ~pf_ForceConfig;
          if (Config)
            Config->SetGlobalSetting(TConfig::st_DefaultsSet,true);
          DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,999),(HWND)0,DlgProc_GlobalSettings,(LPARAM)NULL);
        }
    }
}

static CLSID CLSIDs_AlwaysAllowed[] =
  {
    {0x00000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}}
  };
static CLSID CLSIDs_IEDefault[] =
  {
    {0xA5E46E3A,0x8849,0x11D1,{0x9D,0x8C,0x00,0xC0,0x4F,0xC9,0x9D,0x61}},
    {0x750FDF0E,0x2A26,0x11D1,{0xA3,0xEA,0x08,0x00,0x36,0x58,0x7F,0x03}},
    {0x53BD6B4E,0x3780,0x4693,{0xAF,0xC3,0x71,0x61,0xC2,0xF3,0xEE,0x9C}},
    {0x5B4DAE26,0xB807,0x11D0,{0x98,0x15,0x00,0xC0,0x4F,0xD9,0x19,0x72}},
    {0x0E5CBF21,0xD15F,0x11D0,{0x83,0x01,0x00,0xAA,0x00,0x5B,0x43,0x83}},
    {0x00021401,0x0000,0x0000,{0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46}},
    {0x01E04581,0x4EEE,0x11D0,{0xBF,0xE9,0x00,0xAA,0x00,0x5B,0x43,0x83}},
    {0xE7E4BC40,0xE76A,0x11CE,{0xA9,0xBB,0x00,0xAA,0x00,0x4A,0xE8,0x37}},
    {0x7B8A2D95,0x0AC9,0x11D1,{0x89,0x6C,0x00,0xC0,0x4F,0xB6,0xBF,0xC4}},
    {0x25336920,0x03F9,0x11CF,{0x8F,0xD0,0x00,0xAA,0x00,0x68,0x6F,0x13}},
    {0x25336921,0x03F9,0x11CF,{0x8F,0xD0,0x00,0xAA,0x00,0x68,0x6F,0x13}},
    {0x3050F406,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0xFBF23B40,0xE3F0,0x101B,{0x84,0x88,0x00,0xAA,0x00,0x3E,0x56,0xF8}},
    {0x7B8A2D94,0x0AC9,0x11D1,{0x89,0x6C,0x00,0xC0,0x4F,0xB6,0xBF,0xC4}},
    {0x7B8A2D95,0x0AC9,0x11D1,{0x89,0x6C,0x00,0xC0,0x4F,0xB6,0xBF,0xC4}},
    {0xFF393560,0xC2A7,0x11CF,{0xBF,0xF4,0x44,0x45,0x53,0x54,0x00,0x00}},
    {0x00020420,0x0000,0x0000,{0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46}},
    {0x3050F4F5,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0x275C23E2,0x3747,0x11D0,{0x9F,0xEA,0x00,0xAA,0x00,0x3F,0x86,0x46}},
    {0x3050F3B4,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0x7057E952,0xBD1B,0x11D1,{0x89,0x19,0x00,0xC0,0x4F,0xC2,0xC8,0x36}},
    {0x25336920,0x03F9,0x11CF,{0x8F,0xD0,0x00,0xAA,0x00,0x68,0x6F,0x13}},
    {0x3050F499,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0x3C374A40,0xBAE4,0x11CF,{0xBF,0x7D,0x00,0xAA,0x00,0x69,0x46,0xEE}},
    {0xDD313E04,0xFEFF,0x11D1,{0x8E,0xCD,0x00,0x00,0xF8,0x7A,0x47,0x0C}},
    {0x00000304,0x0000,0x0000,{0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46}},
    {0x0002E005,0x0000,0x0000,{0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46}},
    {0x8F6B0360,0xB80D,0x11D0,{0xA9,0xB3,0x00,0x60,0x97,0x94,0x23,0x11}},
    {0x79EAC9F2,0xBAF9,0x11CE,{0x8C,0x82,0x00,0xAA,0x00,0x4B,0xA9,0x0B}},
    {0x3050F3C2,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0x42AEDC87,0x2188,0x41FD,{0xB9,0xA3,0x0C,0x96,0x6F,0xEA,0xBE,0xC1}},
    {0x7EB5FBE4,0x2100,0x49E6,{0x85,0x93,0x17,0xE1,0x30,0x12,0x2F,0x91}},
    {0x3050F3BC,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0xF61FFEC1,0x754F,0x11D0,{0x80,0xCA,0x00,0xAA,0x00,0x5B,0x43,0x83}},
    {0x871C5380,0x42A0,0x1069,{0xA2,0xEA,0x08,0x00,0x2B,0x30,0x30,0x9D}},
    {0x50D5107A,0xD278,0x4871,{0x89,0x89,0xF4,0xCE,0xAA,0xF5,0x9C,0xFC}},
    {0x3050F391,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0x3050F3DA,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}},
    {0x03C036F1,0xA186,0x11D0,{0x82,0x4A,0x00,0xAA,0x00,0x5B,0x43,0x83}},
    {0x603D3800,0xBD81,0x11D0,{0xA3,0xA5,0x00,0xC0,0x4F,0xD7,0x06,0xEC}},
    {0x64AB4BB7,0x111E,0x11D1,{0x8F,0x79,0x00,0xC0,0x4F,0xC2,0xFB,0xE1}},
    {0xECD4FC4F,0x521C,0x11D0,{0xB7,0x92,0x00,0xA0,0xC9,0x03,0x12,0xE1}},
    {0xE13EF4E4,0xD2F2,0x11D0,{0x98,0x16,0x00,0xC0,0x4F,0xD9,0x19,0x72}},
    {0x00BB2765,0x6A77,0x11D0,{0xA5,0x35,0x00,0xC0,0x4F,0xD7,0xD0,0x62}},
    {0xAF4F6510,0xF982,0x11D0,{0x85,0x95,0x00,0xAA,0x00,0x4C,0xD6,0xD8}},
    {0x6935DB93,0x21E8,0x4CCC,{0xBE,0xB9,0x9F,0xE3,0xC7,0x7A,0x29,0x7A}},
    {0x00BB2764,0x6A77,0x11D0,{0xA5,0x35,0x00,0xC0,0x4F,0xD7,0xD0,0x62}},
    {0x00BB2763,0x6A77,0x11D0,{0xA5,0x35,0x00,0xC0,0x4F,0xD7,0xD0,0x62}},
    {0x68F2D3FC,0x8366,0x4A46,{0x82,0x24,0x58,0xEF,0xA2,0x74,0x94,0x25}},
    {0x8856F961,0x340A,0x11D0,{0xA9,0x6B,0x00,0xC0,0x4F,0xD7,0x05,0xA2}},
    {0xFC7DCECC,0x8017,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x8016,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x8018,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x8019,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x801A,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x801B,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x801C,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x801D,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x801E,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}},
    {0xFC7DCECC,0x801F,0x42D0,{0xB0,0x80,0xB6,0x8A,0x2C,0x18,0xB0,0x95}}
  };
static CLSID CLSIDs_JScript[] =
  {
    {0xF414C260,0x6AC0,0x11CF,{0xB6,0xD1,0x00,0xAA,0x00,0xBB,0xBB,0x58}},
    {0xF414C261,0x6AC0,0x11CF,{0xB6,0xD1,0x00,0xAA,0x00,0xBB,0xBB,0x58}},
    {0x3050F3B2,0x98B5,0x11CF,{0xBB,0x82,0x00,0xAA,0x00,0xBD,0xCE,0x0B}}
  };
static CLSID CLSIDs_VBScript[] =
  {
    {0xB54F3741,0x5B07,0x11CF,{0xA4,0xB0,0x00,0xAA,0x00,0x4A,0x55,0xE8}}
  };
static CLSID CLSIDs_Java[] =
  {
    {0x08B0E5C0,0x4FCB,0x11CF,{0xAA,0xA5,0x00,0x40,0x1C,0x60,0x85,0x01}}
  };
static CLSID CLSIDs_AcrobatReader[] =
  {
    {0x06849E9F,0xC8D7,0x4D59,{0xB8,0x7D,0x78,0x4B,0x7D,0x6B,0xE0,0xB3}},
    {0xCA8A9780,0x280D,0x11CF,{0xA2,0x4D,0x44,0x45,0x53,0x54,0x00,0x00}},
    {0xB801CA65,0xA1FC,0x11D0,{0x85,0xAD,0x44,0x45,0x53,0x54,0x00,0x00}},
  };
static CLSID CLSIDs_Flash[] =
  {
    {0xD27CDB6E,0xAE6D,0x11CF,{0x96,0xB8,0x44,0x45,0x53,0x54,0x00,0x00}}
  };
static CLSID CLSIDs_PNG[] =
  {
    {0x30C3B080,0x30FB,0x11D0,{0xB7,0x24,0x00,0xAA,0x00,0x6C,0x1A,0x01}},
    {0x6A01FDA0,0x30DF,0x11D0,{0xB7,0x24,0x00,0xAA,0x00,0x6C,0x1A,0x01}},
    {0xA3CCEDF7,0x2DE2,0x11D0,{0x86,0xF4,0x00,0xA0,0xC9,0x13,0xF7,0x50}}
  };

static bool IsCLSID(CLSID *ThisCLSID,CLSID *CLSIDList,uint CLSIDCount)
{
  bool Result = false;
  if (ThisCLSID && CLSIDList && CLSIDCount)
    for (uint i = 0;i < CLSIDCount;++i)
      if (!memcmp(ThisCLSID,&CLSIDList[i],sizeof *ThisCLSID))
        {
          Result = true;
          break;
        }
  return Result;
}

static bool __stdcall LogCLSID(uint Mode,CLSID *ClassID)
{
  bool Result = false;
  if (IsBadReadPtr(ClassID,sizeof *ClassID))
    Result = true;
  else
    {
      __try
        {
          char ClassIDStr[80];
          TConfig::CLSID2Str(ClassID,ClassIDStr,sizeof ClassIDStr,0);

          char tmp[4 * 1024];
          if (GlobalPatchFlags & pf_OnlyLogging)
            {
              Result = true;
              StringCbPrintf(tmp,sizeof tmp,"COM Object '%s'(%u)\n",ClassIDStr,Mode);
              OutputDebugString(tmp);
            }
          else
            {
              char ClassIDKey[128];
              TConfig::CLSID2Str(ClassID,ClassIDKey,sizeof ClassIDKey,1);
              char Descr[1024];
              if (!TConfig::GetRegistryClassesRoot(ClassIDKey,NULL,Descr,sizeof Descr))
                Descr[0] = '\0';
              char ClassIDKey2[128];
              StringCbCopy(ClassIDKey2,sizeof ClassIDKey2,ClassIDKey);
              StringCbCat(ClassIDKey2,sizeof ClassIDKey2,"\\InprocServer32");
              bool HasCLSID = false;
              char CtrlFileName[1024];
              if (TConfig::GetRegistryClassesRoot(ClassIDKey2,"",CtrlFileName,sizeof CtrlFileName))
                HasCLSID = true;
              else
                CtrlFileName[0] = '\0';

              bool StateKnown = false;
              bool Ask        = false;

              if (GlobalPatchFlags & pf_AskAlways)
                {
                  StateKnown = true;
                  Ask        = true;
                }
              if (!StateKnown && !HasCLSID)
                {
                  StateKnown = true;
                  Result     = true;
                }
              if (!StateKnown && IsCLSID(ClassID,CLSIDs_AlwaysAllowed,sizeof CLSIDs_AlwaysAllowed / sizeof CLSIDs_AlwaysAllowed[0]))
                {
                  StateKnown = true;
                  Result     = true;
                }

              if (!StateKnown)
                {
                  uint Type;
                  uint Disabled;
                  uint State;
                  if (Config->GetCategorySetting(TConfig::cc_CLSID,ClassIDStr,NULL,&Type,&Disabled,&State,NULL,0))
                    if ((Type == lt_BlackList) && !Disabled)
                      {
                        switch(State)
                          {
                            default:
                            case 0:
                              Result     = false;
                              StateKnown = true;
                              break;

                            case 2:
                              Ask        = true;
                              StateKnown = true;
                              break;
                          }
                      }
                }

              if (!StateKnown && IsCLSID(ClassID,CLSIDs_IEDefault,sizeof CLSIDs_IEDefault / sizeof CLSIDs_IEDefault[0]))
                switch(Config->GetGlobalSetting(TConfig::st_AllowedIEDefaults,true))
                  {
                    case 0:
                      StateKnown = true;
                      Ask        = true;
                      break;

                    default:
                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;
                  }
              if (!StateKnown && IsCLSID(ClassID,CLSIDs_JScript,sizeof CLSIDs_JScript / sizeof CLSIDs_JScript[0]))
                switch(Config->GetGlobalSetting(TConfig::st_AllowedJScript,false))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;
                  }
              if (!StateKnown && IsCLSID(ClassID,CLSIDs_VBScript,sizeof CLSIDs_VBScript / sizeof CLSIDs_VBScript[0]))
                switch(Config->GetGlobalSetting(TConfig::st_AllowedVBScript,false))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;
                  }
              if (!StateKnown && IsCLSID(ClassID,CLSIDs_Java,sizeof CLSIDs_Java / sizeof CLSIDs_Java[0]))
                switch(Config->GetGlobalSetting(TConfig::st_AllowedJava,false))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;
                  }
              if (!StateKnown && IsCLSID(ClassID,CLSIDs_AcrobatReader,sizeof CLSIDs_AcrobatReader / sizeof CLSIDs_AcrobatReader[0]))
                switch(Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;
                  }
              if (!StateKnown && IsCLSID(ClassID,CLSIDs_Flash,sizeof CLSIDs_Flash / sizeof CLSIDs_Flash[0]))
                switch(Config->GetGlobalSetting(TConfig::st_AllowedFlash,false))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;
                  }
              if (!StateKnown && IsCLSID(ClassID,CLSIDs_PNG,sizeof CLSIDs_PNG / sizeof CLSIDs_PNG[0]))
                switch(Config->GetGlobalSetting(TConfig::st_AllowedPNG,false))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;
                  }

              if (!StateKnown)
                {
                  uint Type;
                  uint Disabled;
                  uint State;
                  if (Config->GetCategorySetting(TConfig::cc_CLSID,ClassIDStr,NULL,&Type,&Disabled,&State,NULL,0))
                    if ((Type == lt_WhiteList) && !Disabled)
                      {
                        switch(State)
                          {
                            case 0:
                              Result     = false;
                              StateKnown = true;
                              break;

                            case 1:
                              Result     = true;
                              StateKnown = true;
                              break;

                            default:
                            case 2:
                              Ask        = true;
                              StateKnown = true;
                              break;
                          }
                      }
                }

              if (!StateKnown)
                switch(Config->GetGlobalSetting(TConfig::st_COMDefaultAction,0))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;

                    case 2:
                      break;
                  }

              if (!StateKnown || Ask)
                {
                  if (!CtrlFileName[0])
                    Result = true;
                  else
                    {
                      TQueryData QD;
                      memset(&QD,0,sizeof QD);
                      QD.qd_Descr    = Descr;
                      QD.qd_FileName = CtrlFileName;
                      QD.qd_CLSID    = ClassIDStr;
                      QD.qd_Always   = false;
                      int DlgResult = DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,1),(HWND)0,DlgProc_CLSID,(LPARAM)&QD);
                      switch(DlgResult)
                        {
                          case 1:
                            Result = true;
                            break;

                          default:
                          case 0:
                            Result = false;
                            break;
                        }
                      if (QD.qd_Always)
                        {
                          if (Config)
                            {
                              char Descr2[4 * 1024];
                              StringCbCopy(Descr2,sizeof Descr2,Descr);
                              if (CtrlFileName[0])
                                {
                                  StringCbCat(Descr2,sizeof Descr2,", ");
                                  StringCbCat(Descr2,sizeof Descr2,CtrlFileName);
                                }
                              Config->SetCategorySetting(TConfig::cc_CLSID,ClassIDStr,NULL,true,(Result == false) ? 1 : 2,true,false,true,Result,true,Descr2);
                            }
                        }
                    }
                }

              if ((GlobalPatchFlags & pf_EnableLoggingAll) || (GlobalPatchFlags & pf_EnableLoggingDisabled))
                {
                  if ((GlobalPatchFlags & pf_EnableLoggingDisabled) && Result)
                    ;
                  else
                    {
                      char tmp[1024];
                      StringCbPrintf(tmp,sizeof tmp,"COM Object '%s'(%u): %s(%u)",ClassIDStr,Mode,Result ? "ALLOWED" : "DISABLED",HasCLSID);
                      if (Descr[0])
                        {
                          StringCbCat(tmp,sizeof tmp,": ");
                          StringCbCat(tmp,sizeof tmp,Descr);
                        }
                      if (CtrlFileName[0])
                        {
                          StringCbCat(tmp,sizeof tmp,", ");
                          StringCbCat(tmp,sizeof tmp,CtrlFileName);
                        }
                      StringCbCat(tmp,sizeof tmp,"\n");
                      OutputDebugString(tmp);
                    }
                }
            }
        }
      __except(EXCEPTION_EXECUTE_HANDLER)
        {
        }
    }
  return Result;
}

static bool __stdcall LogProcess(uint Mode,PVOID ImageFileName1,PVOID CmdLine)
{
  bool Result = false;
  __try
    {
      wchar *ImageFileName = NULL;
      if (ImageFileName1)
        {
          UNICODE_STRING *p = (UNICODE_STRING *)ImageFileName1;
          if (p && p->Length && p->Buffer)
            ImageFileName = p->Buffer;
        }
      if (ImageFileName)
        {
          wchar ImageKey[1024];
          Str2KeyNameW(true,ImageFileName,ImageKey,sizeof ImageKey);

          char tmp[4 * 1024];
          if (GlobalPatchFlags & pf_OnlyLogging)
            {
              Result = true;
              StringCbPrintf(tmp,sizeof tmp,"Process '%ws','%ws'(%u)\n",ImageFileName,CmdLine,Mode);
              OutputDebugString(tmp);
            }
          else
            {
              bool  StateKnown = false;
              bool  Ask        = false;
              wchar AppFileName[1024];
              wchar AppFileName2[1024];

              if (GlobalPatchFlags & pf_AskAlways)
                {
                  StateKnown = true;
                  Ask        = true;
                }

              if (!StateKnown)
                {
                  Str2StrW(GlobalLauncherFileName,AppFileName,sizeof AppFileName);
                  if (AppFileName[0] && FileNamesEq(ImageFileName,AppFileName))
                    {
                      StateKnown = true;
                      Result     = true;
                    }
                }

              if (!StateKnown)
                {
                  uint Type;
                  uint Disabled;
                  uint State;
                  if (Config->GetCategorySetting(TConfig::cc_Process,NULL,ImageKey,&Type,&Disabled,&State,NULL,0))
                    if ((Type == lt_BlackList) && !Disabled)
                      {
                        switch(State)
                          {
                            default:
                            case 0:
                              Result     = false;
                              StateKnown = true;
                              break;

                            case 2:
                              Ask        = true;
                              StateKnown = true;
                              break;
                          }
                      }
                }

              if (!StateKnown)
                {
                  if (GetSystemDirectoryW(AppFileName,sizeof AppFileName / sizeof AppFileName[0]) && GetWindowsDirectoryW(AppFileName2,sizeof AppFileName2 / sizeof AppFileName2[0]))
                    {
                      StringCbCatW(AppFileName, sizeof AppFileName, L"\\notepad.exe");
                      StringCbCatW(AppFileName2,sizeof AppFileName2,L"\\notepad.exe");
                      if ((AppFileName[0] && FileNamesEq(ImageFileName,AppFileName)) || (AppFileName2[0] && FileNamesEq(ImageFileName,AppFileName2)))
                        {
                          switch(Config->GetGlobalSetting(TConfig::st_AllowedProcNotepad,true))
                            {
                              default:
                              case 0:
                                StateKnown = true;
                                Result     = false;
                                break;

                              case 1:
                                StateKnown = true;
                                Result     = true;
                                break;
                            }
                        }
                    }
                }

              if (!StateKnown)
                {
                  if (GetAppPath("wmplayer.exe",AppFileName,sizeof AppFileName))
                    if (AppFileName[0] && FileNamesEq(ImageFileName,AppFileName))
                      switch(Config->GetGlobalSetting(TConfig::st_AllowedProcWMPlayer,false))
                        {
                          default:
                          case 0:
                            StateKnown = true;
                            Result     = false;
                            break;

                          case 1:
                            StateKnown = true;
                            Result     = true;
                            break;
                        }
                }

              if (!StateKnown)
                {
                  if (GlobalAcrobatFileName[0] && FileNamesEq(ImageFileName,GlobalAcrobatFileName))
                    switch(Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                      {
                        default:
                        case 0:
                          StateKnown = true;
                          Result     = false;
                          break;

                        case 1:
                          StateKnown = true;
                          Result     = true;
                          break;
                      }
                }

              if (!StateKnown)
                {
                  if (GetAppPath("RealPlay.exe",AppFileName,sizeof AppFileName))
                    if (AppFileName[0] && FileNamesEq(ImageFileName,AppFileName))
                      switch(Config->GetGlobalSetting(TConfig::st_AllowedProcRealPlayer,false))
                        {
                          default:
                          case 0:
                            StateKnown = true;
                            Result     = false;
                            break;

                          case 1:
                            StateKnown = true;
                            Result     = true;
                            break;
                        }
                }

              if (!StateKnown)
                {
                  if (GetAppPath("Winword.exe",AppFileName,sizeof AppFileName))
                    if (AppFileName[0] && FileNamesEq(ImageFileName,AppFileName))
                      switch(Config->GetGlobalSetting(TConfig::st_AllowedProcWord,false))
                        {
                          default:
                          case 0:
                            StateKnown = true;
                            Result     = false;
                            break;

                          case 1:
                            StateKnown = true;
                            Result     = true;
                            break;
                        }
                }

              if (!StateKnown)
                {
                  if (GetAppPath("EXCEL.EXE",AppFileName,sizeof AppFileName))
                    if (AppFileName[0] && FileNamesEq(ImageFileName,AppFileName))
                      switch(Config->GetGlobalSetting(TConfig::st_AllowedProcExcel,false))
                        {
                          default:
                          case 0:
                            StateKnown = true;
                            Result     = false;
                            break;

                          case 1:
                            StateKnown = true;
                            Result     = true;
                            break;
                        }
                }

              if (!StateKnown)
                {
                  if (GetAppPath("POWERPNT.EXE",AppFileName,sizeof AppFileName))
                    if (AppFileName[0] && FileNamesEq(ImageFileName,AppFileName))
                      switch(Config->GetGlobalSetting(TConfig::st_AllowedProcPowerPoint,false))
                        {
                          default:
                          case 0:
                            StateKnown = true;
                            Result     = false;
                            break;

                          case 1:
                            StateKnown = true;
                            Result     = true;
                            break;
                        }
                }


              if (!StateKnown)
                {
                  uint Type;
                  uint Disabled;
                  uint State;
                  if (Config->GetCategorySetting(TConfig::cc_Process,NULL,ImageKey,&Type,&Disabled,&State,NULL,0))
                    if ((Type == lt_WhiteList) && !Disabled)
                      {
                        switch(State)
                          {
                            case 0:
                              Result     = false;
                              StateKnown = true;
                              break;

                            case 1:
                              Result     = true;
                              StateKnown = true;
                              break;

                            default:
                            case 2:
                              Ask        = true;
                              StateKnown = true;
                              break;
                          }
                      }
                }

              if (!StateKnown)
                switch(Config->GetGlobalSetting(TConfig::st_AppDefaultAction,2))
                  {
                    default:
                    case 0:
                      StateKnown = true;
                      Result     = false;
                      break;

                    case 1:
                      StateKnown = true;
                      Result     = true;
                      break;

                    case 2:
                      break;
                  }

              if (!StateKnown || Ask)
                {
                  TProcessData PD;
                  memset(&PD,0,sizeof PD);
                  PD.pd_ImageFileName = ImageFileName;
                  PD.pd_CmdLine       = CmdLine;
                  PD.pd_Always        = false;
                  int DlgResult = DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,2),(HWND)0,DlgProc_Process,(LPARAM)&PD);
                  switch(DlgResult)
                    {
                      case 1:
                        Result = true;
                        break;

                      default:
                      case 0:
                        Result = false;
                        break;
                    }
                  if (PD.pd_Always)
                    {
                      if (Config)
                        {
                          Config->SetCategorySetting(TConfig::cc_Process,NULL,ImageKey,true,(Result == false) ? 1 : 2,true,false,true,Result,false,NULL);
                        }
                    }
                }

              if ((GlobalPatchFlags & pf_EnableLoggingAll) || (GlobalPatchFlags & pf_EnableLoggingDisabled))
                {
                  if ((GlobalPatchFlags & pf_EnableLoggingDisabled) && Result)
                    ;
                  else
                    {
                      char tmp[1024];
                      StringCbPrintf(tmp,sizeof tmp,"Application '%ws': %s",ImageFileName,Result ? "ALLOWED" : "DISABLED");
                      StringCbCat(tmp,sizeof tmp,"\n");
                      OutputDebugString(tmp);
                    }
                }
            }
        }
    }
  __except(EXCEPTION_EXECUTE_HANDLER)
    {
      Result = false;
    }
  return Result;
}

static bool __stdcall LogFiles(uint Mode,PVOID ObjectAttributes,ULONG Access)
{

  bool Result = false;
  __try
    {
      const uint TmpSize = 4 * 1024;
      char *tmp = new char[TmpSize];
      const uint FileNameSize = 4 * 1024;
      wchar *FileName1 = new wchar[FileNameSize];
      const uint FileNameKeySize = 4 * 1024;
      wchar *FileNameKey = new wchar[FileNameKeySize];
      if (tmp && FileName1 && FileNameKey)
        {
          PObjectAttributes OA = (PObjectAttributes)ObjectAttributes;
          if (!OA)
            Result = true;
          else
            {
              UNICODE_STRING *US = OA->oa_ObjectName;

              if (GlobalPatchFlags & pf_OnlyLogging)
                {
                  Result = true;
                  StringCbPrintf(tmp,TmpSize,"File[%u,%08X] '%ws'\n",Mode,Access,US && US->Buffer ? US->Buffer : L"???");
                  OutputDebugString(tmp);
                }
              else
                {
                  if (US && US->Buffer)
                    {
                      PWSTR RealFileName = US->Buffer;

                      if ((RealFileName[0] == '\\') && (RealFileName[1] == '?') && (RealFileName[2] == '?') && (RealFileName[3] == '\\')
                       && ((RealFileName[4] == 'P') || (RealFileName[4] == 'p')) && ((RealFileName[5] == 'I') || (RealFileName[5] == 'i')) && ((RealFileName[6] == 'P') || (RealFileName[6] == 'p')) && ((RealFileName[7] == 'E') || (RealFileName[7] == 'e')) && (RealFileName[8] == '\\'))
                        Result = true;
                      else if ((RealFileName[0] == '\\') && (RealFileName[1] == '?') && (RealFileName[2] == '?') && (RealFileName[3] == '\\')
                            && (RealFileName[4] == 'M') && (RealFileName[5] == 'o') && (RealFileName[6] == 'u') && (RealFileName[7] == 'n') && (RealFileName[8] == 't')
                            && (RealFileName[9] == 'P') && (RealFileName[10] == 'o') && (RealFileName[11] == 'i') && (RealFileName[12] == 'n') && (RealFileName[13] == 't')
                            && (RealFileName[14] == 'M') && (RealFileName[15] == 'a') && (RealFileName[16] == 'n') && (RealFileName[17] == 'a') && (RealFileName[18] == 'g') && (RealFileName[19] == 'e') && (RealFileName[20] == 'r') && !RealFileName[21])
                        Result = true;
                      else if ((RealFileName[0] == '\\') && (RealFileName[1] == 'D') && (RealFileName[2] == 'e') && (RealFileName[3] == 'v') && (RealFileName[4] == 'i') && (RealFileName[5] == 'c') && (RealFileName[6] == 'e') && (RealFileName[7] == '\\')
                            && (RealFileName[8] == 'K') && (RealFileName[9] == 's') && (RealFileName[10] == 'e') && (RealFileName[11] == 'c') && (RealFileName[12] == 'D') && (RealFileName[13] == 'D') && !RealFileName[14])
                        Result = true;
                      else
                        {
                          PWSTR FileName = RealFileName;
                          if ((FileName[0] == '\\') && (FileName[1] == '?') && (FileName[2] == '?') && (FileName[3] == '\\') && FileName[4] && (FileName[5] == ':'))
                            FileName += 4;

                          bool  StateKnown = false;
                          bool  Ask        = false;

                          Str2KeyNameW(true,FileName,FileNameKey,FileNameKeySize * sizeof FileNameKey[0]);

                          if (GlobalPatchFlags & pf_AskAlways)
                            {
                              StateKnown = true;
                              Ask        = true;
                            }

                          Access &= ~0x00000100;

                          Access &= ~0x00100000;

                          if (!StateKnown)
                            {
                              if (!Access)
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }
                            }

                          if (!StateKnown)
                            {
                              Str2StrW(GlobalLauncherFileName,FileName1,FileNameSize * sizeof FileName1[0]);
                              if (FileName1[0] && FileNamesEq(FileName,FileName1))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }
                            }

                          if (!StateKnown)
                            {
                              uint Type;
                              uint Disabled;
                              uint State;
                              if (Config->GetCategorySetting(TConfig::cc_File,NULL,FileNameKey,&Type,&Disabled,&State,NULL,0))
                                if ((Type == lt_BlackList) && !Disabled)
                                  {
                                    switch(State)
                                      {
                                        default:
                                        case 0:
                                          Result     = false;
                                          StateKnown = true;
                                          break;

                                        case 2:
                                          Ask        = true;
                                          StateKnown = true;
                                          break;
                                      }
                                  }
                            }

                          if (!StateKnown)
                            {
                              boolean IsIP = false;

                              if (!IsIP && (RealFileName[0] == '\\') && (RealFileName[1] == 'D') && (RealFileName[2] == 'e') && (RealFileName[3] == 'v') && (RealFileName[4] == 'i') && (RealFileName[5] == 'c') && (RealFileName[6] == 'e') && (RealFileName[7] == '\\')
                                    && (RealFileName[8] == 'R') && (RealFileName[9] == 'a') && (RealFileName[10] == 's') && (RealFileName[11] == 'A') && (RealFileName[12] == 'c') && (RealFileName[13] == 'd') && !RealFileName[14])
                                {
                                  IsIP = true;
                                }
                              else if (!IsIP && (RealFileName[0] == '\\') && (RealFileName[1] == 'D') && (RealFileName[2] == 'e') && (RealFileName[3] == 'v') && (RealFileName[4] == 'i') && (RealFileName[5] == 'c') && (RealFileName[6] == 'e') && (RealFileName[7] == '\\')
                                    && (RealFileName[8] == 'A') && (RealFileName[9] == 'f') && (RealFileName[10] == 'd') && (RealFileName[11] == '\\')
                                    && (RealFileName[12] == 'E') && (RealFileName[13] == 'n') && (RealFileName[14] == 'd') && (RealFileName[15] == 'p') && (RealFileName[16] == 'o') && (RealFileName[17] == 'i') && (RealFileName[18] == 'n') && (RealFileName[19] == 't') && !RealFileName[20])
                                {
                                  IsIP = true;
                                }
                              else if (!IsIP && (RealFileName[0] == '\\') && (RealFileName[1] == 'D') && (RealFileName[2] == 'e') && (RealFileName[3] == 'v') && (RealFileName[4] == 'i') && (RealFileName[5] == 'c') && (RealFileName[6] == 'e') && (RealFileName[7] == '\\')
                                    && (RealFileName[8] == 'A') && (RealFileName[9] == 'f') && (RealFileName[10] == 'd') && (RealFileName[11] == '\\')
                                    && (RealFileName[12] == 'A') && (RealFileName[13] == 's') && (RealFileName[14] == 'y') && (RealFileName[15] == 'n') && (RealFileName[16] == 'c')
                                    && (RealFileName[17] == 'C') && (RealFileName[18] == 'o') && (RealFileName[19] == 'n') && (RealFileName[20] == 'n') && (RealFileName[21] == 'e') && (RealFileName[22] == 'c') && (RealFileName[23] == 't')
                                    && (RealFileName[24] == 'H')  && (RealFileName[25] == 'l')  && (RealFileName[26] == 'p') && !RealFileName[27])
                                {
                                  IsIP = true;
                                }
                              if (IsIP)
                                {
                                  StateKnown = true;
                                  Result = (Config->GetGlobalSetting(TConfig::st_AllowedIP,true) != 0);
                                }
                            }

                          bool IsReadAccess = true;
                          if (Access & (FILE_WRITE_DATA | FILE_APPEND_DATA | FILE_WRITE_EA | FILE_DELETE_CHILD | FILE_WRITE_ATTRIBUTES | DELETE | WRITE_DAC | WRITE_OWNER | GENERIC_WRITE))
                            IsReadAccess = false;

                          if (!StateKnown)
                            {
                              if (IsReadAccess)
                                {
                                  if (CompareStringW(LOCALE_USER_DEFAULT,NORM_IGNORECASE,FileName,(DWORD)-1,GlobalSystemDrive,(DWORD)-1) == CSTR_EQUAL)
                                    {
                                      StateKnown = true;
                                      Result     = true;
                                    }
                                }
                            }

                          if (!StateKnown && IsReadAccess)
                            {
                              if (GlobalSystemDir[0] && FileNamesEq(FileName,GlobalSystemDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileSystemRead,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Ask        = true;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }
                          if (!StateKnown && IsReadAccess)
                            {
                              if (GlobalWindowsSxSDir[0] && FileNamesEq(FileName,GlobalWindowsSxSDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileSystemRead,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Ask        = true;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }
                          if (!StateKnown && IsReadAccess)
                            {
                              if (GlobalWindowsDir[0] && FileNamesEq(FileName,GlobalWindowsDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileSystemRead,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Ask        = true;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }

                          if (!StateKnown)
                            {
                              if (GlobalInternetCacheDir[0] && FileNamesEq(FileName,GlobalInternetCacheDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileBrowserCache,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Result     = false;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }

                          if (!StateKnown)
                            {
                              if (GlobalInternetHistoryDir[0] && FileNamesEq(FileName,GlobalInternetHistoryDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileBrowserHistory,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Result     = false;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }

                          if (!StateKnown)
                            {
                              if (GlobalCookiesDir[0] && FileNamesEq(FileName,GlobalCookiesDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileCookies,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Result     = false;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }

                          if (!StateKnown)
                            {
                              if (GlobalDesktopDir[0] && FileNamesEq(FileName,GlobalDesktopDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileDesktop,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Result     = false;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }

                          if (!StateKnown)
                            {
                              if (GlobalFavoritesDir[0] && FileNamesEq(FileName,GlobalFavoritesDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileFavorites,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Result     = false;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }

                          if (!StateKnown)
                            {
                              if (GlobalTempDir[0] && FileNamesEq(FileName,GlobalTempDir,true))
                                {
                                  switch(Config->GetGlobalSetting(TConfig::st_AllowedFileTemp,true))
                                    {
                                      default:
                                      case 0:
                                        StateKnown = true;
                                        Result     = false;
                                        break;

                                      case 1:
                                        StateKnown = true;
                                        Result     = true;
                                        break;
                                    }
                                }
                            }

                          if (!StateKnown && GlobalAcrobatFileName[0])
                            if (FileNamesEq(FileName,GlobalAcrobatFileName))
                              if (Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false) || Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }
                          if (!StateKnown && GlobalAcrobatFileName2[0])
                            if (FileNamesEq(FileName,GlobalAcrobatFileName2))
                              if (Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false) || Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }
                          if (!StateKnown && GlobalAcrobatFileName3[0])
                            if (FileNamesEq(FileName,GlobalAcrobatFileName3))
                              if (Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false) || Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }
                          if (!StateKnown && GlobalAcrobatFileName4[0])
                            if (FileNamesEq(FileName,GlobalAcrobatFileName4))
                              if (Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false) || Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }

                          if (!StateKnown && GlobalIEFileName[0])
                            if (FileNamesEq(FileName,GlobalIEFileName))
                              if (Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false) || Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }

                          if (!StateKnown && GlobalAcroOCX1FileName[0])
                            if (FileNamesEq(FileName,GlobalAcroOCX1FileName))
                              if (Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false) || Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }

                          if (!StateKnown && GlobalAcroOCX2FileName[0])
                            if (FileNamesEq(FileName,GlobalAcroOCX2FileName))
                              if (Config->GetGlobalSetting(TConfig::st_AllowedAcrobatReader,false) || Config->GetGlobalSetting(TConfig::st_AllowedProcAcroRd32,false))
                                {
                                  StateKnown = true;
                                  Result     = true;
                                }

                          if (!StateKnown)
                            {
                              uint Type;
                              uint Disabled;
                              uint State;
                              if (Config->GetCategorySetting(TConfig::cc_File,NULL,FileNameKey,&Type,&Disabled,&State,NULL,0))
                                if ((Type == lt_WhiteList) && !Disabled)
                                  {
                                    switch(State)
                                      {
                                        case 0:
                                          Result     = false;
                                          StateKnown = true;
                                          break;

                                        case 1:
                                          Result     = true;
                                          StateKnown = true;
                                          break;

                                        default:
                                        case 2:
                                          Ask        = true;
                                          StateKnown = true;
                                          break;
                                      }
                                  }
                            }

                          if (!StateKnown)
                            switch(Config->GetGlobalSetting(TConfig::st_FileDefaultAction,1))
                              {
                                default:
                                case 0:
                                  StateKnown = true;
                                  Result     = false;
                                  break;

                                case 1:
                                  StateKnown = true;
                                  Result     = true;
                                  break;

                                case 2:
                                  break;
                              }

                          if (!StateKnown || Ask)
                            {
                              TFileData FD;
                              memset(&FD,0,sizeof FD);
                              FD.fd_FileName = FileName;
                              FD.fd_Mode     = Mode;
                              FD.fd_Access   = Access;
                              FD.fd_Always   = false;
                              int DlgResult = DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,3),(HWND)0,DlgProc_File,(LPARAM)&FD);
                              switch(DlgResult)
                                {
                                  case 1:
                                    Result = true;
                                    break;

                                  default:
                                  case 0:
                                    Result = false;
                                    break;
                                }
                              if (FD.fd_Always)
                                {
                                  if (Config)
                                    {
                                      Config->SetCategorySetting(TConfig::cc_File,NULL,FileNameKey,true,(Result == false) ? 1 : 2,true,false,true,Result,false,NULL);
                                    }
                                }
                            }

                          if ((GlobalPatchFlags & pf_EnableLoggingAll) || (GlobalPatchFlags & pf_EnableLoggingDisabled))
                            {
                              if ((GlobalPatchFlags & pf_EnableLoggingDisabled) && Result)
                                ;
                              else
                                {
                                  StringCbPrintf(tmp,TmpSize,"File '%ws': %s",FileName,Result ? "ALLOWED" : "DISABLED");
                                  StringCbCat(tmp,TmpSize,"\n");
                                  OutputDebugString(tmp);
                                }
                            }
                        }
                    }
                  else
                    {
                      Result = true;
                    }
                }
            }
        }
      if (tmp)         delete [] tmp;
      if (FileName1)   delete [] FileName1;
      if (FileNameKey) delete [] FileNameKey;
    }
  __except(EXCEPTION_EXECUTE_HANDLER)
    {
      Result = false;
    }
  return Result;
}

static bool __stdcall LogINet(uint Mode,PVOID Param1,PVOID Param2,PVOID Param3,PVOID Param4,PVOID Param5,PVOID Param6)
{
  bool Result = false;
  __try
    {
      char HostName[256];
      switch(Mode)
        {
          case 1:
          case 11:
            StringCbCopy(HostName,sizeof HostName,(LPCTSTR)Param1);
            break;

          case 2:
          case 12:
            StringCbPrintf(HostName,sizeof HostName,"%ws",(LPCWSTR)Param1);
            break;

          default:
            HostName[0] = '\0';
            break;
        }

      char tmp[4 * 1024];
      if ((GlobalPatchFlags & pf_OnlyLogging) || Config->GetGlobalSetting(TConfig::st_LogData,false))
        {
          tmp[0] = '\0';
          switch(Mode)
            {
              case 1:
                {
                  LPCTSTR ServerName = (LPCTSTR)Param1;
                  WORD    ServerPort = (WORD)Param2;
                  LPCTSTR UserName   = (LPCTSTR)Param3;
                  LPCTSTR Password   = (LPCTSTR)Param4;
                  DWORD   Service    = (DWORD)Param5;
                  DWORD   Flags      = (DWORD)Param6;
                  StringCbPrintf(tmp,sizeof tmp,"InternetConnectA(ServerName:'%s',ServerPort:%u,UserName:'%s',Password:'%s',Service:0x%X,Flags:0x%X)\n",ServerName ? ServerName : "???",ServerPort,UserName ? UserName : "",Password ? Password : "",Service,Flags);
                }
                break;

              case 2:
                {
                  LPCWSTR ServerName = (LPCWSTR)Param1;
                  WORD    ServerPort = (WORD)Param2;
                  LPCWSTR UserName   = (LPCWSTR)Param3;
                  LPCWSTR Password   = (LPCWSTR)Param4;
                  DWORD   Service    = (DWORD)Param5;
                  DWORD   Flags      = (DWORD)Param6;
                  StringCbPrintf(tmp,sizeof tmp,"InternetConnectW(ServerName:'%ws',ServerPort:%u,UserName:'%ws',Password:'%ws',Service:0x%X,Flags:0x%X)\n",ServerName ? ServerName : (LPCWSTR)"???",ServerPort,UserName ? UserName : (LPCWSTR)"",Password ? Password : (LPCWSTR)"",Service,Flags);
                }
                break;

              case 11:
                {
                  LPCTSTR Url     = (LPCTSTR)Param1;
                  LPCTSTR Headers = (LPCTSTR)Param2;
                  StringCbPrintf(tmp,sizeof tmp,"InternetOpenUrlA(Url:'%s',Headers:'%s')\n",Url ? Url : "???",Headers ? Headers : "");
                }
                break;

              case 12:
                {
                  LPCWSTR Url     = (LPCWSTR)Param1;
                  LPCWSTR Headers = (LPCWSTR)Param2;
                  StringCbPrintf(tmp,sizeof tmp,"InternetOpenUrlW(Url:'%ws',Headers:'%ws')\n",Url ? Url : (LPCWSTR)"???",Headers ? Headers : (LPCWSTR)"");
                }
                break;
            }

          if (tmp[0])
            OutputDebugString(tmp);
        }

      if (GlobalPatchFlags & pf_OnlyLogging)
        {
          Result = true;
        }
      else
        {
          bool Blocked = false;
          if (!Blocked && !Config->GetGlobalSetting(TConfig::st_AllowedServerRelLinks,false))
            {
              char *p = StrStrI(HostName,"related.msn.com");
              if (!p)
                p = StrStrI(HostName,".alexa.com");
              if (p)
                Blocked = true;
            }

          if (!Blocked && !Config->GetGlobalSetting(TConfig::st_AllowedServerAds,false))
            {
              if (StrStrI(HostName,".adserver."))
                Blocked = true;
              else if (StrStrI(HostName,".hitbox."))
                Blocked = true;
              else if ((HostName[0] == 'a') && (HostName[1] == 'd') && (HostName[2] == '.'))
                Blocked = true;
              else if ((HostName[0] == 'a') && (HostName[1] == 'd') && (HostName[2] == 's') && (HostName[3] == '.'))
                Blocked = true;
              else if ((HostName[0] == 'a') && (HostName[1] == 'd') && (HostName[2] == 'i') && (HostName[3] == 'm') && (HostName[4] == 'g') && (HostName[5] == '.'))
                Blocked = true;
              else if ((HostName[0] == 'a') && (HostName[1] == 'd') && (HostName[2] == 'l') && (HostName[3] == 'o') && (HostName[4] == 'g') && (HostName[5] == '.'))
                Blocked = true;
              else if ((HostName[0] == 'a') && (HostName[1] == 'd') && (HostName[2] == 's') && (HostName[3] == 'e') && (HostName[4] == 'r') && (HostName[5] == 'v'))
                Blocked = true;
              else if ((HostName[0] == 'p') && (HostName[1] == 'a') && (HostName[2] == 'g') && (HostName[3] == 'e') && (HostName[4] == 'a') && (HostName[5] == 'd'))
                Blocked = true;
            }

          if (Blocked)
            {
              StringCbPrintf(tmp,sizeof tmp,"BLOCKED[%u]: '%s'\n",Mode,HostName);
              OutputDebugString(tmp);
            }
          else
            {
              bool StateKnown = false;
              bool Ask        = false;

              if (GlobalPatchFlags & pf_AskAlways)
                {
                  StateKnown = true;
                  Ask        = true;
                }

              if (!StateKnown)
                {
                  uint Type;
                  uint Disabled;
                  uint State;
                  if (Config->GetCategorySetting(TConfig::cc_INet,HostName,NULL,&Type,&Disabled,&State,NULL,0))
                    if ((Type == lt_BlackList) && !Disabled)
                      {
                        switch(State)
                          {
                            default:
                            case 0:
                              Result     = false;
                              StateKnown = true;
                              break;

                            case 2:
                              Ask        = true;
                              StateKnown = true;
                              break;
                          }
                      }
                }

              if (!StateKnown)
                {
                  uint Type;
                  uint Disabled;
                  uint State;
                  if (Config->GetCategorySetting(TConfig::cc_INet,HostName,NULL,&Type,&Disabled,&State,NULL,0))
                    if ((Type == lt_WhiteList) && !Disabled)
                      {
                        switch(State)
                          {
                            case 0:
                              Result     = false;
                              StateKnown = true;
                              break;

                            case 1:
                              Result     = true;
                              StateKnown = true;
                              break;

                            default:
                            case 2:
                              Ask        = true;
                              StateKnown = true;
                              break;
                          }
                      }
                }

              if (!StateKnown || Ask)
                {
                  uint x = Config->GetGlobalSetting(TConfig::st_INetDefaultAction,1);
                  switch(x)
                    {
                      case 0:
                        Result = false;
                        break;

                      case 1:
                        Result = true;
                        break;

                      default:
                      case 2:
                        {
                          TINetData ID;
                          memset(&ID,0,sizeof ID);
                          ID.id_HostName = HostName;
                          ID.id_Mode     = Mode;
                          ID.id_Always   = false;
                          int DlgResult = DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,4),(HWND)0,DlgProc_INet,(LPARAM)&ID);
                          switch(DlgResult)
                            {
                              case 1:
                                Result = true;
                                break;

                              default:
                              case 0:
                                Result = false;
                                break;
                            }
                          if (ID.id_Always)
                            {
                              if (Config)
                                {
                                  Config->SetCategorySetting(TConfig::cc_INet,HostName,NULL,true,(Result == false) ? 1 : 2,true,false,true,Result,false,NULL);
                                }
                            }
                        }
                        break;
                    }
                }
            }
        }
    }
  __except(EXCEPTION_EXECUTE_HANDLER)
    {
      Result = false;
    }
  return Result;
}

class TDumpMemory
  {
  public:
    TDumpMemory(PVOID ADataHandle,PVOID AMemBase,uint AMemSize,bool ALongOfs = false);
    virtual ~TDumpMemory();
    void Dump(uint BytesPerLine = 16,uint SegmentOfs = 0,uint SegmentSize = 0);
  protected:
    virtual bool Out(char *s1,char *s2,char *s3);
  private:
    PVOID DataHandle;
    PBYTE MemBase;
    uint  MemSize;
    bool  LongOfs;
  };
typedef TDumpMemory * PDumpMemory;

TDumpMemory::TDumpMemory(PVOID ADataHandle,PVOID AMemBase,uint AMemSize,bool ALongOfs)
{
  DataHandle = ADataHandle;
  MemBase    = (PBYTE)AMemBase;
  MemSize    = AMemSize;
  LongOfs    = ALongOfs;
}

TDumpMemory::~TDumpMemory()
{
}

bool TDumpMemory::Out(char *s1,char *s2,char *s3)
{
  bool Result = false;
  if (s1 || s2 || s3)
    {
      char tmp[1024],tmp1[80];
      tmp[0] = '\0';
      if (s1)
        {
          StringCbPrintf(tmp1,sizeof tmp1,"%p|%s: ",DataHandle,s1);
          StringCbCat(tmp,sizeof tmp,tmp1);
        }
      if (s2)
        {
          StringCbCat(tmp,sizeof tmp,s2);
        }
      if (s3)
        {
          StringCbCat(tmp,sizeof tmp,"  ");
          StringCbCat(tmp,sizeof tmp,s3);
        }
      StringCbCat(tmp,sizeof tmp,"\n");
      OutputDebugString(tmp);
      Result = true;
    }
  return Result;
}

void TDumpMemory::Dump(uint BytesPerLine,uint SegmentOfs,uint SegmentSize)
{
  if ((MemSize > 0) && (SegmentOfs < MemSize) && (BytesPerLine > 0))
    {
      if (!SegmentSize || (SegmentSize > MemSize))
        SegmentSize = MemSize;

      char tmp0[80];
      uint Tmp1Size = 3 * BytesPerLine + 1;
      uint Tmp2Size = BytesPerLine + 1;
      char *tmp1 = new char[Tmp1Size];
      char *tmp2 = new char[Tmp2Size];
      bool NoData = true;
      if (tmp1 && tmp2)
        {
          for (uint CurIndex = 0;(SegmentOfs + CurIndex) < SegmentSize;++CurIndex)
            {
              bool IsLineStart = false;
              if (!(CurIndex % BytesPerLine))
                IsLineStart = true;
              bool IsLineEnd = false;
              if ((CurIndex % BytesPerLine) == (BytesPerLine - 1))
                IsLineEnd = true;

              if (IsLineStart)
                {
                  if (LongOfs)
                    StringCbPrintf(tmp0,sizeof tmp0,"%08X",SegmentOfs + CurIndex);
                  else
                    StringCbPrintf(tmp0,sizeof tmp0,"%04X",SegmentOfs + CurIndex);
                  tmp1[0] = '\0';
                  tmp2[0] = '\0';
                }

              char tmp[80];
              StringCbPrintf(tmp,sizeof tmp,"%02X ",MemBase[SegmentOfs + CurIndex]);
              StringCbCat(tmp1,Tmp1Size,tmp);

              tmp[0] = MemBase[SegmentOfs + CurIndex];
              if (tmp[0] < 0x20)
                tmp[0] = '.';
              tmp[1] = '\0';
              StringCbCat(tmp2,Tmp2Size,tmp);
              NoData = false;

              if (IsLineEnd)
                {
                  Out(tmp0,tmp1,tmp2);
                  NoData = true;
                }
            }
          if (!NoData)
            {
              while (strlen(tmp1) < (Tmp1Size - 1))
                StringCbCat(tmp1,Tmp1Size," ");
              Out(tmp0,tmp1,tmp2);
            }
        }
      if (tmp1) delete [] tmp1;
      if (tmp2) delete [] tmp2;
    }
}

static void __stdcall LogData(uint Mode,PVOID Param1,PVOID Param2,PVOID Param3,PVOID Param4,PVOID Param5,PVOID Param6,PVOID Param7,PVOID Param8)
{
  __try
    {
      if (Config->GetGlobalSetting(TConfig::st_LogData,false))
        {
          PVOID DataHandle = NULL;
          PBYTE DataPtr    = NULL;
          DWORD DataSize   = 0;
          PBYTE Data2Ptr   = NULL;
          DWORD Data2Size  = 0;

          char tmp[1024];
          switch(Mode)
            {
              case 1:
                {
                  BOOL                FuncResult            = (BOOL)Param1;
                  HANDLE/*HINTERNET*/ hFile                 = (HANDLE/*HINTERNET*/)Param2;
                  LPVOID              lpBuffer              = (LPVOID)Param3;
                  DWORD               dwNumberOfBytesToRead = (DWORD)Param4;
                  LPDWORD             lpdwNumberOfBytesRead = (LPDWORD)Param5;
                  StringCbPrintf(tmp,sizeof tmp,"InternetReadFile(hFile:%p,lpBuffer:%p,dwNumberOfBytesToRead:%u,lpdwNumberOfBytesRead:%p->%u) -> %u",hFile,lpBuffer,dwNumberOfBytesToRead,lpdwNumberOfBytesRead,lpdwNumberOfBytesRead ? *lpdwNumberOfBytesRead : 0,FuncResult);
                  OutputDebugString(tmp);

                  if (FuncResult)
                    {
                      DataHandle = (PVOID)hFile;
                      DataPtr    = (PBYTE)lpBuffer;
                      DataSize   = lpdwNumberOfBytesRead ? *lpdwNumberOfBytesRead : 0;
                    }
                }
                break;

              case 2:
                {
                  BOOL                        FuncResult   = (BOOL)Param1;
                  HANDLE/*HINTERNET*/         hFile        = (HANDLE/*HINTERNET*/)Param2;
                  PVOID/*LPINTERNET_BUFFERS*/ lpBuffersOut = (PVOID)Param3;
                  DWORD                       dwFlags      = (DWORD)Param4;
                  DWORD                       dwContext    = (DWORD)Param5;
                  StringCbPrintf(tmp,sizeof tmp,"InternetReadFileExA(hFile:%p,lpBuffersOut:%p,dwFlags:%X,dwContext:%p) -> %u",hFile,lpBuffersOut,dwFlags,dwContext,FuncResult);
                  OutputDebugString(tmp);

                  if (FuncResult)
                    {
                      PBYTE p = (PBYTE)lpBuffersOut;
                      DataHandle = (PVOID)hFile;
                      DataPtr    = *((PBYTE *)(p + 0x14));
                      DataSize   = *((DWORD *)(p + 0x18));
                    }
                }
                break;

              case 3:
                {
                  BOOL                FuncResult               = (BOOL)Param1;
                  HANDLE/*HINTERNET*/ hFile                    = (HANDLE/*HINTERNET*/)Param2;
                  LPVOID              lpBuffer                 = (LPVOID)Param3;
                  DWORD               dwNumberOfBytesToWrite   = (DWORD)Param4;
                  LPDWORD             lpdwNumberOfBytesWritten = (LPDWORD)Param5;
                  StringCbPrintf(tmp,sizeof tmp,"InternetWriteFile(hFile:%p,lpBuffer:%p,dwNumberOfBytesToWrite:%u,lpdwNumberOfBytesWritten:%p->%u) -> %u",hFile,lpBuffer,dwNumberOfBytesToWrite,lpdwNumberOfBytesWritten,lpdwNumberOfBytesWritten ? *lpdwNumberOfBytesWritten : 0,FuncResult);
                  OutputDebugString(tmp);

                  DataHandle = (PVOID)hFile;
                  DataPtr    = (PBYTE)lpBuffer;
                  DataSize   = lpdwNumberOfBytesWritten ? *lpdwNumberOfBytesWritten : 0;
                }
                break;

              case 4:
                {
                  HANDLE/*HINTERNET*/ hRequest         = (HANDLE/*HINTERNET*/)Param1;
                  LPCTSTR             lpszHeaders      = (LPCTSTR)Param2;
                  DWORD               dwHeadersLength  = (DWORD)Param3;
                  LPVOID              lpOptional       = (LPVOID)Param4;
                  DWORD               dwOptionalLength = (DWORD)Param5;
                  DWORD RealHeadersLength = dwHeadersLength;
                  if (RealHeadersLength == (DWORD)-1)
                    RealHeadersLength = strlen(lpszHeaders);
                  StringCbPrintf(tmp,sizeof tmp,"HttpSendRequestA(hRequest:%p,lpszHeaders:%p,dwHeadersLength:%u->%u,lpOptional:%p,dwOptionalLength:%u)",hRequest,lpszHeaders,dwHeadersLength,RealHeadersLength,lpOptional,dwOptionalLength);
                  OutputDebugString(tmp);

                  DataHandle = (PVOID)hRequest;
                  DataPtr    = (PBYTE)lpszHeaders;
                  DataSize   = RealHeadersLength;
                  Data2Ptr   = (PBYTE)lpOptional;
                  Data2Size  = dwOptionalLength;
                }
                break;

              case 5:
                {
                  HANDLE/*HINTERNET*/ hRequest         = (HANDLE/*HINTERNET*/)Param1;
                  LPCWSTR             lpszHeaders      = (LPCWSTR)Param2;
                  DWORD               dwHeadersLength  = (DWORD)Param3;
                  LPVOID              lpOptional       = (LPVOID)Param4;
                  DWORD               dwOptionalLength = (DWORD)Param5;
                  DWORD RealHeadersLength = dwHeadersLength;
                  if (RealHeadersLength == (DWORD)-1)
                    RealHeadersLength = lstrlenW(lpszHeaders);
                  StringCbPrintf(tmp,sizeof tmp,"HttpSendRequestW(hRequest:%p,lpszHeaders:%p,dwHeadersLength:%u->%u,lpOptional:%p,dwOptionalLength:%u)",hRequest,lpszHeaders,dwHeadersLength,RealHeadersLength,lpOptional,dwOptionalLength);
                  OutputDebugString(tmp);

                  DataHandle = (PVOID)hRequest;
                  DataPtr    = (PBYTE)lpszHeaders;
                  DataSize   = RealHeadersLength * sizeof(wchar);
                  Data2Ptr   = (PBYTE)lpOptional;
                  Data2Size  = dwOptionalLength;
                }
                break;

              case 6:
                {
                  HANDLE/*HINTERNET*/ hConnect        = (HANDLE/*HINTERNET*/)Param1;
                  LPCTSTR             lpszVerb        = (LPCTSTR)Param2;
                  LPCTSTR             lpszObjectName  = (LPCTSTR)Param3;
                  LPCTSTR             lpszVersion     = (LPCTSTR)Param4;
                  LPCTSTR             lpszReferer     = (LPCTSTR)Param5;
                  PVOID               lpszAcceptTypes = (PVOID)Param6;
                  DWORD               dwFlags         = (DWORD)Param7;
                  DWORD_PTR           dwContext       = (DWORD_PTR)Param8;
                  StringCbPrintf(tmp,sizeof tmp,"HttpOpenRequestA(hConnect:%p,lpszVerb:'%s',lpszObjectName:'%s',lpszVersion:'%s',lpszReferer:'%s',lpszAcceptTypes:%p,dwFlags:%08X,dwContext:%p)",hConnect,lpszVerb ? lpszVerb : "<NULL>",lpszObjectName ? lpszObjectName : "<NULL>",lpszVersion ? lpszVersion : "<NULL>",lpszReferer ? lpszReferer : "<NULL>",lpszAcceptTypes,dwFlags,dwContext);
                  OutputDebugString(tmp);
                }
                break;

              case 7:
                {
                  HANDLE/*HINTERNET*/ hConnect        = (HANDLE/*HINTERNET*/)Param1;
                  LPCWSTR             lpszVerb        = (LPCWSTR)Param2;
                  LPCWSTR             lpszObjectName  = (LPCWSTR)Param3;
                  LPCWSTR             lpszVersion     = (LPCWSTR)Param4;
                  LPCWSTR             lpszReferer     = (LPCWSTR)Param5;
                  PVOID               lpszAcceptTypes = (PVOID)Param6;
                  DWORD               dwFlags         = (DWORD)Param7;
                  DWORD_PTR           dwContext       = (DWORD_PTR)Param8;
                  StringCbPrintf(tmp,sizeof tmp,"HttpOpenRequestW(hConnect:%p,lpszVerb:'%ws',lpszObjectName:'%ws',lpszVersion:'%ws',lpszReferer:'%ws',lpszAcceptTypes:%p,dwFlags:%08X,dwContext:%p)",hConnect,lpszVerb ? lpszVerb : L"<NULL>",lpszObjectName ? lpszObjectName : L"<NULL>",lpszVersion ? lpszVersion : L"<NULL>",lpszReferer ? lpszReferer : L"<NULL>",lpszAcceptTypes,dwFlags,dwContext);
                  OutputDebugString(tmp);
                }
                break;
            }

          if (DataPtr && DataSize)
            {
              PDumpMemory DM = new TDumpMemory(DataHandle,DataPtr,DataSize);
              if (DM)
                {
                  DM->Dump();
                  delete DM;
                }
            }
          if (Data2Ptr && Data2Size)
            {
              PDumpMemory DM = new TDumpMemory(DataHandle,Data2Ptr,Data2Size);
              if (DM)
                {
                  DM->Dump();
                  delete DM;
                }
            }
        }
    }
  __except(EXCEPTION_EXECUTE_HANDLER)
    {
    }
}


static bool __stdcall LogDNS(uint /*Mode*/,PVOID Param1,PVOID Param2)
{
  const BYTE VeriSign_IP1 =  64;
  const BYTE VeriSign_IP2 =  94;
  const BYTE VeriSign_IP3 = 110;
  const BYTE VeriSign_IP4 =  11;
  bool Result = true;
  __try
    {
      if (Config->GetGlobalSetting(TConfig::st_DisableVeriSign,true))
        {
          WSAQUERYSETW *WQS    = (WSAQUERYSETW *)Param2;
          if (WQS)
            {
              if (WQS->dwNameSpace == NS_DNS)
                {
                  PBYTE IPData = NULL;
                  if (WQS->dwNumberOfCsAddrs >= 1)
                    {
                      LPCSADDR_INFO AddrBuf = WQS->lpcsaBuffer;
                      if (AddrBuf)
                        {
                          LPSOCKADDR SA = AddrBuf->RemoteAddr.lpSockaddr;
                          if (SA)
                            {
                              IPData = (PBYTE)&SA->sa_data[2];
                            }
                        }
                    }
                  else if (WQS->lpBlob)
                    {
                      PBYTE BD = WQS->lpBlob->pBlobData;
                      if (BD)
                        {
                          DWORD DataSize = *(DWORD *)BD;
                          DWORD Ofs1     = *(DWORD *)(BD + 3 * sizeof(DWORD));
                          if ((Ofs1 + 4) <= DataSize)
                            {
                              DWORD Ofs2     = *(DWORD *)(BD + Ofs1);
                              if ((Ofs2 + 4) <= DataSize)
                                {
                                  IPData = BD + Ofs2;
                                }
                            }
                        }
                    }
                  if (IPData)
                    {
                      BYTE IP1 = IPData[0];
                      BYTE IP2 = IPData[1];
                      BYTE IP3 = IPData[2];
                      BYTE IP4 = IPData[3];
                      if ((IP1 == VeriSign_IP1) && (IP2 == VeriSign_IP2) && (IP3 == VeriSign_IP3) && (IP4 == VeriSign_IP4))
                        Result = false;
                    }
                }
            }
        }
    }
  __except(EXCEPTION_EXECUTE_HANDLER)
    {
    }
  return Result;
}

////////////////////////////////////////////////////////////////////////////////

static PVOID OrigContAddr_CoCreateInstanceEx = NULL;

extern "C" __declspec(naked) HRESULT __stdcall My_CoCreateInstanceEx_Type1(CLSID * /*ClassID*/,PVOID /*punkOuter*/,DWORD /*dwClsCtx*/,PVOID /*pServerInfo*/,ULONG /*cmq*/,PVOID /*pResults*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   1
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm JMP    DWORD PTR OrigContAddr_CoCreateInstanceEx

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    6 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_CoCreateInstanceEx_Type2(CLSID * /*ClassID*/,PVOID /*punkOuter*/,DWORD /*dwClsCtx*/,PVOID /*pServerInfo*/,ULONG /*cmq*/,PVOID /*pResults*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   1
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm PUSH   0
  __asm JMP    DWORD PTR OrigContAddr_CoCreateInstanceEx

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    6 * 4
}

static PVOID OrigCallAddr_CoCreateInstanceEx = NULL;

extern "C" __declspec(naked) HRESULT __stdcall My_CoCreateInstanceEx_Type3(CLSID * /*ClassID*/,PVOID /*punkOuter*/,DWORD /*dwClsCtx*/,PVOID /*pServerInfo*/,ULONG /*cmq*/,PVOID /*pResults*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   1
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm CALL   OrigCallAddr_CoCreateInstanceEx
  __asm JMP    DWORD PTR OrigContAddr_CoCreateInstanceEx

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    6 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_CoCreateInstanceEx_Type4(CLSID * /*ClassID*/,PVOID /*punkOuter*/,DWORD /*dwClsCtx*/,PVOID /*pServerInfo*/,ULONG /*cmq*/,PVOID /*pResults*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   1
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm SUB    ESP,0x0278
  __asm JMP    DWORD PTR OrigContAddr_CoCreateInstanceEx

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    6 * 4
}

static PVOID OrigContAddr_CoGetClassObject = NULL;

extern "C" __declspec(naked) HRESULT __stdcall My_CoGetClassObject_Type1(CLSID * /*ClassID*/,IN DWORD /*dwClsContext*/,IN LPVOID /*pvReserved*/,IN REFIID /*riid*/,OUT LPVOID FAR* /*ppv*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   2
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm PUSH   0
  __asm JMP    DWORD PTR OrigContAddr_CoGetClassObject

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    5 * 4
}

static PVOID OrigCallAddr_CoGetClassObject = NULL;

extern "C" __declspec(naked) HRESULT __stdcall My_CoGetClassObject_Type2(CLSID * /*ClassID*/,IN DWORD /*dwClsContext*/,IN LPVOID /*pvReserved*/,IN REFIID /*riid*/,OUT LPVOID FAR* /*ppv*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   2
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm CALL   OrigCallAddr_CoGetClassObject
  __asm JMP    DWORD PTR OrigContAddr_CoGetClassObject

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    5 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_CoGetClassObject_Type3(CLSID * /*ClassID*/,IN DWORD /*dwClsContext*/,IN LPVOID /*pvReserved*/,IN REFIID /*riid*/,OUT LPVOID FAR* /*ppv*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   2
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm PUSH   ESI
  __asm PUSH   DWORD PTR [EBP+18h]
  __asm JMP    DWORD PTR OrigContAddr_CoGetClassObject

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    5 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_CoGetClassObject_Type4(CLSID * /*ClassID*/,IN DWORD /*dwClsContext*/,IN LPVOID /*pvReserved*/,IN REFIID /*riid*/,OUT LPVOID FAR* /*ppv*/)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm MOV    EAX,[EBP+8]
  __asm PUSH   EAX
  __asm PUSH   2
  __asm CALL   LogCLSID
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm JMP    DWORD PTR OrigContAddr_CoGetClassObject

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0x80004002
  __asm POP    EBP
  __asm RET    5 * 4
}

static PVOID OrigContAddr_RtlCreateProcessParameters = NULL;

extern "C" __declspec(naked) HRESULT __stdcall My_RtlCreateProcessParameters_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+12]
  __asm PUSH   1
  __asm CALL   LogProcess
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm PUSH   -1
  __asm JMP    DWORD PTR OrigContAddr_RtlCreateProcessParameters

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0xC0000022
  __asm POP    EBP
  __asm RET    10 * 4
}

static DWORD OrigPushAddr_RtlCreateProcessParameters = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_RtlCreateProcessParameters_Type2(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+12]
  __asm PUSH   1
  __asm CALL   LogProcess
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   0x2C
  __asm PUSH   OrigPushAddr_RtlCreateProcessParameters
  __asm JMP    DWORD PTR OrigContAddr_RtlCreateProcessParameters

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0xC0000022
  __asm POP    EBP
  __asm RET    10 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_RtlCreateProcessParameters_Type3(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+12]
  __asm PUSH   1
  __asm CALL   LogProcess
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   0x28
  __asm PUSH   OrigPushAddr_RtlCreateProcessParameters
  __asm JMP    DWORD PTR OrigContAddr_RtlCreateProcessParameters

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0xC0000022
  __asm POP    EBP
  __asm RET    10 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_RtlCreateProcessParameters_Type4(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+12]
  __asm PUSH   1
  __asm CALL   LogProcess
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm MOV    EAX,FS:[0]
  __asm JMP    DWORD PTR OrigContAddr_RtlCreateProcessParameters

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0xC0000022
  __asm POP    EBP
  __asm RET    10 * 4
}

static PVOID OrigContAddr_NtCreateFile = NULL;
static DWORD OrigValue_NtCreateFile    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_NtCreateFile_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+16]
  __asm PUSH   1
  __asm CALL   LogFiles
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm MOV    EAX,OrigValue_NtCreateFile
  __asm JMP    DWORD PTR OrigContAddr_NtCreateFile

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0xC0000022
  __asm POP    EBP
  __asm RET    11 * 4
}

static PVOID OrigContAddr_NtOpenFile = NULL;
static DWORD OrigValue_NtOpenFile    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_NtOpenFile_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+16]
  __asm PUSH   2
  __asm CALL   LogFiles
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm MOV    EAX,OrigValue_NtOpenFile
  __asm JMP    DWORD PTR OrigContAddr_NtOpenFile

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0xC0000022
  __asm POP    EBP
  __asm RET    6 * 4
}

static PVOID OrigContAddr_NtDeleteFile = NULL;
static DWORD OrigValue_NtDeleteFile    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_NtDeleteFile_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   [EBP+8]
  __asm PUSH   3
  __asm CALL   LogFiles
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm MOV    EAX,OrigValue_NtDeleteFile
  __asm JMP    DWORD PTR OrigContAddr_NtDeleteFile

L_Fail:
  __asm POPAD
  __asm MOV    EAX,0xC0000022
  __asm POP    EBP
  __asm RET    6 * 4
}

static PVOID OrigContAddr_InternetConnectA = NULL;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetConnectA_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   1
  __asm CALL   LogINet
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   EBP
  __asm LEA    EBP,[ESP-228H]
  __asm JMP    DWORD PTR OrigContAddr_InternetConnectA

L_Fail:
  __asm PUSH   5
  __asm CALL   DWORD PTR SetLastError
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm POP    EBP
  __asm RET    8 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_InternetConnectA_Type2(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   1
  __asm CALL   LogINet
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   EBP
  __asm LEA    EBP,[ESP-58H]
  __asm JMP    DWORD PTR OrigContAddr_InternetConnectA

L_Fail:
  __asm PUSH   5
  __asm CALL   DWORD PTR SetLastError
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm POP    EBP
  __asm RET    8 * 4
}

static DWORD OrigValue_InternetConnectA = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetConnectA_Type3(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   1
  __asm CALL   LogINet
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_InternetConnectA
  __asm JMP    DWORD PTR OrigContAddr_InternetConnectA

L_Fail:
  __asm PUSH   5
  __asm CALL   DWORD PTR SetLastError
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm POP    EBP
  __asm RET    8 * 4
}

static PVOID OrigContAddr_InternetConnectW = NULL;
static DWORD OrigValue_InternetConnectW    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetConnectW_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   2
  __asm CALL   LogINet
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_InternetConnectW
  __asm JMP    DWORD PTR OrigContAddr_InternetConnectW

L_Fail:
  __asm PUSH   5
  __asm CALL   DWORD PTR SetLastError
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm POP    EBP
  __asm RET    8 * 4
}

static PVOID OrigContAddr_InternetOpenUrlA = NULL;
static DWORD OrigPushAddr_InternetOpenUrlA = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetOpenUrlA_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   11
  __asm CALL   LogINet
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   24H
  __asm PUSH   OrigPushAddr_InternetOpenUrlA
  __asm JMP    DWORD PTR OrigContAddr_InternetOpenUrlA

L_Fail:
  __asm PUSH   5
  __asm CALL   DWORD PTR SetLastError
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm POP    EBP
  __asm RET    6 * 4
}

extern "C" __declspec(naked) HRESULT __stdcall My_InternetOpenUrlA_Type2(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   11
  __asm CALL   LogINet
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   0xFFFFFFFF
  __asm JMP    DWORD PTR OrigContAddr_InternetOpenUrlA

L_Fail:
  __asm PUSH   5
  __asm CALL   DWORD PTR SetLastError
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm POP    EBP
  __asm RET    6 * 4
}

static PVOID OrigContAddr_InternetOpenUrlW = NULL;
static DWORD OrigValue_InternetOpenUrlW    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetOpenUrlW_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   12
  __asm CALL   LogINet
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
  __asm POP    EBP
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_InternetOpenUrlW
  __asm JMP    DWORD PTR OrigContAddr_InternetOpenUrlW

L_Fail:
  __asm PUSH   5
  __asm CALL   DWORD PTR SetLastError
  __asm POPAD
  __asm XOR    EAX,EAX
  __asm POP    EBP
  __asm RET    6 * 4
}

static PVOID OrigContAddr_InternetReadFile = NULL;
static DWORD OrigValue_InternetReadFile    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetReadFile_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   EAX
  __asm PUSH   1
  __asm CALL   LogData
  __asm POPAD
  __asm POP    EBP
  __asm RET    4 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_InternetReadFile
  __asm JMP    DWORD PTR OrigContAddr_InternetReadFile
}

static PVOID OrigContAddr_InternetReadFileExA = NULL;
static DWORD OrigValue_InternetReadFileExA    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetReadFileExA_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   EAX
  __asm PUSH   2
  __asm CALL   LogData
  __asm POPAD
  __asm POP    EBP
  __asm RET    4 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_InternetReadFileExA
  __asm JMP    DWORD PTR OrigContAddr_InternetReadFileExA
}

static PVOID OrigContAddr_InternetWriteFile = NULL;
static DWORD OrigValue_InternetWriteFile    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_InternetWriteFile_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   EAX
  __asm PUSH   3
  __asm CALL   LogData
  __asm POPAD
  __asm POP    EBP
  __asm RET    4 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_InternetWriteFile
  __asm JMP    DWORD PTR OrigContAddr_InternetWriteFile
}

static PVOID OrigContAddr_HttpSendRequestA = NULL;
static DWORD OrigValue_HttpSendRequestA    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_HttpSendRequestA_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   4
  __asm CALL   LogData
  __asm POPAD
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm POP    EBP
  __asm RET    5 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   OrigValue_HttpSendRequestA
  __asm JMP    DWORD PTR OrigContAddr_HttpSendRequestA
}

static PVOID OrigContAddr_HttpSendRequestW = NULL;
static DWORD OrigValue_HttpSendRequestW    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_HttpSendRequestW_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   5
  __asm CALL   LogData
  __asm POPAD
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm POP    EBP
  __asm RET    5 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_HttpSendRequestW
  __asm JMP    DWORD PTR OrigContAddr_HttpSendRequestW
}

extern "C" __declspec(naked) HRESULT __stdcall My_HttpSendRequestW_Type2(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   0
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   5
  __asm CALL   LogData
  __asm POPAD
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm POP    EBP
  __asm RET    5 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   ECX
  __asm PUSH   ECX
  __asm JMP    DWORD PTR OrigContAddr_HttpSendRequestW
}

static PVOID OrigContAddr_HttpOpenRequestA = NULL;
static DWORD OrigValue_HttpOpenRequestA    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_HttpOpenRequestA_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+36]
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   6
  __asm CALL   LogData
  __asm POPAD
  __asm PUSH   [EBP+36]
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm POP    EBP
  __asm RET    8 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_HttpOpenRequestA
  __asm JMP    DWORD PTR OrigContAddr_HttpOpenRequestA
}

static PVOID OrigContAddr_HttpOpenRequestW = NULL;
static DWORD OrigValue_HttpOpenRequestW    = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_HttpOpenRequestW_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSHAD
  __asm PUSH   [EBP+36]
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm PUSH   7
  __asm CALL   LogData
  __asm POPAD
  __asm PUSH   [EBP+36]
  __asm PUSH   [EBP+32]
  __asm PUSH   [EBP+28]
  __asm PUSH   [EBP+24]
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm POP    EBP
  __asm RET    8 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue_HttpOpenRequestW
  __asm JMP    DWORD PTR OrigContAddr_HttpOpenRequestW
}

static PVOID OrigContAddr_WSALookupServiceNextW = NULL;
static DWORD OrigValue1_WSALookupServiceNextW   = 0;
static DWORD OrigValue2_WSALookupServiceNextW   = 0;

extern "C" __declspec(naked) HRESULT __stdcall My_WSALookupServiceNextW_Type1(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm CMP    EAX,-1
  __asm JE     L_Skip
  __asm PUSHAD
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   0
  __asm CALL   LogDNS
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
L_Skip:
  __asm POP    EBP
  __asm RET    4 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   EAX
  __asm PUSH   EBX
  __asm MOV    EAX,OrigValue1_WSALookupServiceNextW
  __asm MOV    EBX,OrigValue2_WSALookupServiceNextW
  __asm CMP    [EAX],EBX
  __asm POP    EBX
  __asm POP    EAX
  __asm JMP    DWORD PTR OrigContAddr_WSALookupServiceNextW

L_Fail:
  __asm POPAD
  __asm PUSH   11001
  __asm CALL   DWORD PTR SetLastError
  __asm MOV    EAX,-1
  __asm JMP    L_Skip
}

extern "C" __declspec(naked) HRESULT __stdcall My_WSALookupServiceNextW_Type2(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm CMP    EAX,-1
  __asm JE     L_Skip
  __asm PUSHAD
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   0
  __asm CALL   LogDNS
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
L_Skip:
  __asm POP    EBP
  __asm RET    4 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm SUB    ESP,OrigValue1_WSALookupServiceNextW
  __asm JMP    DWORD PTR OrigContAddr_WSALookupServiceNextW

L_Fail:
  __asm POPAD
  __asm PUSH   11001
  __asm CALL   DWORD PTR SetLastError
  __asm MOV    EAX,-1
  __asm JMP    L_Skip
}

extern "C" __declspec(naked) HRESULT __stdcall My_WSALookupServiceNextW_Type3(void)
{
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   [EBP+12]
  __asm PUSH   [EBP+8]
  __asm CALL   OrigFunc
  __asm CMP    EAX,-1
  __asm JE     L_Skip
  __asm PUSHAD
  __asm PUSH   [EBP+20]
  __asm PUSH   [EBP+16]
  __asm PUSH   0
  __asm CALL   LogDNS
  __asm TEST   EAX,EAX
  __asm JZ     L_Fail
  __asm POPAD
L_Skip:
  __asm POP    EBP
  __asm RET    4 * 4

OrigFunc:
  __asm PUSH   EBP
  __asm MOV    EBP,ESP
  __asm PUSH   ECX
  __asm PUSH   ECX
  __asm JMP    DWORD PTR OrigContAddr_WSALookupServiceNextW

L_Fail:
  __asm POPAD
  __asm PUSH   11001
  __asm CALL   DWORD PTR SetLastError
  __asm MOV    EAX,-1
  __asm JMP    L_Skip
}

////////////////////////////////////////////////////////////////////////////////

static DWORD WINAPI WatchThread(LPVOID /*Param*/)
{
  for (;;)
    {
      if ((GetAsyncKeyState(VK_CAPITAL) < 0) && (GetAsyncKeyState(VK_MENU) < 0))
        {
          DialogBoxParam(GlobalModuleHandle,TConfig::ResGetDlgId(GlobalModuleHandle,999),(HWND)0,DlgProc_GlobalSettings,(LPARAM)1);
        }
      Sleep(1 * 1000);
    }
}

static void StartWatchThread(void)
{
  DWORD  TID;
  HANDLE TH  = CreateThread(NULL,64 * 1024,(LPTHREAD_START_ROUTINE)WatchThread,NULL,0,&TID);
  if (TH)
    CloseHandle(TH);
}

////////////////////////////////////////////////////////////////////////////////

static bool SetHook(bool OnlyPatchCheck,PBYTE Buf2,PVOID NewAddr,PVOID OrigAddr,uint x,PVOID *OrigContAddr,HANDLE CurProcess)
{
  bool Result = false;
  if (OnlyPatchCheck)
    Result = true;
  else
    {
      const uint Buf2Size = sizeof(BYTE) + sizeof(DWORD_PTR);
      Buf2[0] = 0xE9;
      DWORD_PTR DestAddr = ((DWORD_PTR)NewAddr) - ((DWORD_PTR)OrigAddr) - Buf2Size;
      *((PDWORD_PTR)&Buf2[1]) = DestAddr;
      *OrigContAddr = ((PBYTE)OrigAddr) + x;
      DWORD BytesWritten;
      if (WriteProcessMemory(CurProcess,OrigAddr,Buf2,Buf2Size,&BytesWritten) && (BytesWritten == Buf2Size))
        {
          FlushInstructionCache(CurProcess,OrigAddr,Buf2Size);
          Result = true;
        }
    }
  return Result;
}

static bool Ole32InstanceLoaded   = false;
static bool WinINetInstanceLoaded = false;

extern "C" __declspec(dllexport) uint __stdcall Patch(void *ModuleHandle,unsigned long PatchFlags,char *ConfigKeyName,char *CfgName,char *LauncherFileName)
{
  bool Result = false;

  HANDLE CurProcess = GetCurrentProcess();

  bool OnlyPatchCheck = (PatchFlags & pf_OnlyPatchCheck) != 0;
  if (!OnlyPatchCheck)
    {
      GlobalModuleHandle = (HINSTANCE)ModuleHandle;
      GlobalBigIcon      = LoadImage(GlobalModuleHandle,MAKEINTRESOURCE(1),IMAGE_ICON,32,32,0);
      GlobalSmallIcon    = LoadImage(GlobalModuleHandle,MAKEINTRESOURCE(1),IMAGE_ICON,16,16,0);
      GlobalPatchFlags   = PatchFlags;
      GetModuleFileName(0,GlobalAppName,sizeof GlobalAppName);
      if (LauncherFileName)
        StringCbCopy(GlobalLauncherFileName,sizeof GlobalLauncherFileName,LauncherFileName);
      if (ConfigKeyName)
        StringCbCopy(GlobalConfigKeyName,sizeof GlobalConfigKeyName,ConfigKeyName);
      if (CfgName)
        StringCbCopy(GlobalCfgName,sizeof GlobalCfgName,CfgName);
      GlobalPopupMenu = LoadMenu(GlobalModuleHandle,TConfig::ResGetMenuId(GlobalModuleHandle,100));
      if (!GetWindowsDirectoryW(GlobalWindowsDir,sizeof GlobalWindowsDir / sizeof GlobalWindowsDir[0]))
        GlobalWindowsDir[0] = '\0';
      if (GlobalWindowsDir[0])
        {
          StringCbCopyW(GlobalWindowsSxSDir,sizeof GlobalWindowsSxSDir,GlobalWindowsDir);
          StringCbCatW(GlobalWindowsSxSDir,sizeof GlobalWindowsSxSDir,L"\\WinSxS");
        }
      if (!GetSystemDirectoryW(GlobalSystemDir,sizeof GlobalSystemDir / sizeof GlobalSystemDir[0]))
        GlobalSystemDir[0] = '\0';
      if (!GetTempPathW(sizeof GlobalTempDir / sizeof GlobalTempDir[0],GlobalTempDir))
        GlobalTempDir[0] = '\0';

      if (GlobalSystemDir[0] && (GlobalSystemDir[1] == ':') && (GlobalSystemDir[2] == '\\'))
        {
          GlobalSystemDrive[0] = GlobalSystemDir[0];
          GlobalSystemDrive[1] = GlobalSystemDir[1];
          GlobalSystemDrive[2] = GlobalSystemDir[2];
          GlobalSystemDrive[3] = '\0';
        }
      InitFileNameEqFuncs();

      bool IsOk = false;
      const char *ShellDllLibName = "shell32.dll";
      HINSTANCE ShellDllInstance = GetModuleHandle(ShellDllLibName);
      if (ShellDllInstance)
        {
          typedef HRESULT (__stdcall *TSHGetFolderPath)(HWND hwndOwner,int nFolder,HANDLE hToken,DWORD dwFlags,LPWSTR pszPath);
          TSHGetFolderPath Func_SHGetFolderPathW = (TSHGetFolderPath)GetProcAddress(ShellDllInstance,"SHGetFolderPathW");
          if (Func_SHGetFolderPathW)
            {
              IsOk = true;
              if (!SUCCEEDED(Func_SHGetFolderPathW(NULL,CSIDL_INTERNET_CACHE,NULL,SHGFP_TYPE_CURRENT,GlobalInternetCacheDir)))
                GlobalInternetCacheDir[0] = '\0';
              if (!SUCCEEDED(Func_SHGetFolderPathW(NULL,CSIDL_HISTORY,NULL,SHGFP_TYPE_CURRENT,GlobalInternetHistoryDir)))
                GlobalInternetHistoryDir[0] = '\0';
              if (!SUCCEEDED(Func_SHGetFolderPathW(NULL,CSIDL_COOKIES,NULL,SHGFP_TYPE_CURRENT,GlobalCookiesDir)))
                GlobalCookiesDir[0] = '\0';
              if (!SUCCEEDED(Func_SHGetFolderPathW(NULL,CSIDL_DESKTOPDIRECTORY,NULL,SHGFP_TYPE_CURRENT,GlobalDesktopDir)))
                GlobalDesktopDir[0] = '\0';
              if (!SUCCEEDED(Func_SHGetFolderPathW(NULL,CSIDL_FAVORITES,NULL,SHGFP_TYPE_CURRENT,GlobalFavoritesDir)))
                GlobalFavoritesDir[0] = '\0';
            }
        }
      if (!IsOk)
        {
          LPITEMIDLIST List = NULL;
          if (!SUCCEEDED(SHGetSpecialFolderLocation(NULL,CSIDL_INTERNET_CACHE,&List)) || !SHGetPathFromIDListW(List,GlobalInternetCacheDir))
            GlobalInternetCacheDir[0] = '\0';
          else
            {
              LPMALLOC pMalloc;
              if (SUCCEEDED(SHGetMalloc(&pMalloc)))
                {
                  pMalloc->Free(List);
                  pMalloc->Release();
                }
            }

          List = NULL;
          if (!SUCCEEDED(SHGetSpecialFolderLocation(NULL,CSIDL_HISTORY,&List)) || !SHGetPathFromIDListW(List,GlobalInternetHistoryDir))
            GlobalInternetHistoryDir[0] = '\0';
          else
            {
              LPMALLOC pMalloc;
              if (SUCCEEDED(SHGetMalloc(&pMalloc)))
                {
                  pMalloc->Free(List);
                  pMalloc->Release();
                }
            }

          List = NULL;
          if (!SUCCEEDED(SHGetSpecialFolderLocation(NULL,CSIDL_COOKIES,&List)) || !SHGetPathFromIDListW(List,GlobalCookiesDir))
            GlobalCookiesDir[0] = '\0';
          else
            {
              LPMALLOC pMalloc;
              if (SUCCEEDED(SHGetMalloc(&pMalloc)))
                {
                  pMalloc->Free(List);
                  pMalloc->Release();
                }
            }

          List = NULL;
          if (!SUCCEEDED(SHGetSpecialFolderLocation(NULL,CSIDL_DESKTOPDIRECTORY,&List)) || !SHGetPathFromIDListW(List,GlobalDesktopDir))
            GlobalDesktopDir[0] = '\0';
          else
            {
              LPMALLOC pMalloc;
              if (SUCCEEDED(SHGetMalloc(&pMalloc)))
                {
                  pMalloc->Free(List);
                  pMalloc->Release();
                }
            }

          List = NULL;
          if (!SUCCEEDED(SHGetSpecialFolderLocation(NULL,CSIDL_FAVORITES,&List)) || !SHGetPathFromIDListW(List,GlobalFavoritesDir))
            GlobalFavoritesDir[0] = '\0';
          else
            {
              LPMALLOC pMalloc;
              if (SUCCEEDED(SHGetMalloc(&pMalloc)))
                {
                  pMalloc->Free(List);
                  pMalloc->Release();
                }
            }

        }

      if (!GetAppPath("AcroRd32.exe",GlobalAcrobatFileName,sizeof GlobalAcrobatFileName))
        GlobalAcrobatFileName[0] = '\0';
      else
        {
          StringCbCopyW(GlobalAcrobatFileName2,sizeof GlobalAcrobatFileName2,GlobalAcrobatFileName);
          StringCbCatW(GlobalAcrobatFileName2,sizeof GlobalAcrobatFileName2,L".Config");
          StringCbCopyW(GlobalAcrobatFileName3,sizeof GlobalAcrobatFileName3,GlobalAcrobatFileName);
          StringCbCatW(GlobalAcrobatFileName3,sizeof GlobalAcrobatFileName3,L".Manifest");
          StringCbCopyW(GlobalAcrobatFileName4,sizeof GlobalAcrobatFileName4,GlobalAcrobatFileName);
          PWCHAR p = StrStrIW(GlobalAcrobatFileName4,L"\\AcroRd32.exe");
          if (p)
            {
              *p = '\0';
              StringCbCatW(GlobalAcrobatFileName4,sizeof GlobalAcrobatFileName4,L"\\plug_ins\\EWH32.api");
            }
          else
            GlobalAcrobatFileName4[0] = '\0';
        }

      if (!GetAppPath("iexplore.exe",GlobalIEFileName,sizeof GlobalIEFileName))
        GlobalIEFileName[0] = '\0';

      char ClassIDKey[128],ClassIDKey2[128];
      char CtrlFileName[1024];

      TConfig::CLSID2Str(&CLSIDs_AcrobatReader[0],ClassIDKey,sizeof ClassIDKey,1);
      StringCbCopy(ClassIDKey2,sizeof ClassIDKey2,ClassIDKey);
      StringCbCat(ClassIDKey2,sizeof ClassIDKey2,"\\InprocServer32");
      if (TConfig::GetRegistryClassesRoot(ClassIDKey2,"",CtrlFileName,sizeof CtrlFileName))
        Str2StrW(CtrlFileName,GlobalAcroOCX1FileName,sizeof GlobalAcroOCX1FileName);

      TConfig::CLSID2Str(&CLSIDs_AcrobatReader[1],ClassIDKey,sizeof ClassIDKey,1);
      StringCbCopy(ClassIDKey2,sizeof ClassIDKey2,ClassIDKey);
      StringCbCat(ClassIDKey2,sizeof ClassIDKey2,"\\InprocServer32");
      if (TConfig::GetRegistryClassesRoot(ClassIDKey2,"",CtrlFileName,sizeof CtrlFileName))
        Str2StrW(CtrlFileName,GlobalAcroOCX2FileName,sizeof GlobalAcroOCX2FileName);

      InitCommonControls();
    }

  if (!OnlyPatchCheck)
    {
      Config = new TConfig(GlobalConfigKeyName,GlobalCfgName,(PatchFlags & pf_ROConfig) != 0,(PatchFlags & pf_GlobalConfig) != 0);
      if (!Config || !Config->ConfigOk)
        Result = false;
      else
        {
          if (Config && Config->GetGlobalSetting(TConfig::st_LogAll,false))
            GlobalPatchFlags |= pf_EnableLoggingAll;
          if (Config && Config->GetGlobalSetting(TConfig::st_LogDisabled,false))
            GlobalPatchFlags |= pf_EnableLoggingDisabled;
        }

      TConfig::ResLoadString(GlobalModuleHandle,strStatusValueAllow,   StatusValue_Allow,   sizeof StatusValue_Allow);
      TConfig::ResLoadString(GlobalModuleHandle,strStatusValueDisallow,StatusValue_Disallow,sizeof StatusValue_Disallow);
      TConfig::ResLoadString(GlobalModuleHandle,strStatusValueAsk,     StatusValue_Ask,     sizeof StatusValue_Ask);

      CheckDefaultConfig();
    }

  Result = true;

  DWORD BytesRead;
  BYTE  Buf[13],Buf2[sizeof(BYTE) + sizeof(DWORD_PTR)];

  if (Result && !(PatchFlags & pf_SkipNtDll))
    {
      Result = false;

      const char *NtDllLibName = "ntdll.dll";
      HINSTANCE NtDllInstance = GetModuleHandle(NtDllLibName);
      if (NtDllInstance)
        {
          Result = true;

          PVOID Func_RtlCreateProcessParameters = GetProcAddress(NtDllInstance,"RtlCreateProcessParameters");
          if (Result && Func_RtlCreateProcessParameters)
            {
              Result = false;
              if (ReadProcessMemory(CurProcess,Func_RtlCreateProcessParameters,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                {
                  if (!memcmp(Buf,"\x55\x8B\xEC\x6A\xFF",5))
                    {
                      Result = SetHook(OnlyPatchCheck,Buf2,My_RtlCreateProcessParameters_Type1,Func_RtlCreateProcessParameters,5,&OrigContAddr_RtlCreateProcessParameters,CurProcess);
                    }
                  else if (!memcmp(Buf,"\x6A\x2C\x68",3))
                    {
                      OrigPushAddr_RtlCreateProcessParameters = *(LPDWORD)(Buf + 3);
                      Result = SetHook(OnlyPatchCheck,Buf2,My_RtlCreateProcessParameters_Type2,Func_RtlCreateProcessParameters,7,&OrigContAddr_RtlCreateProcessParameters,CurProcess);
                    }
                  else if (!memcmp(Buf,"\x6A\x28\x68",3))
                    {
                      OrigPushAddr_RtlCreateProcessParameters = *(LPDWORD)(Buf + 3);
                      Result = SetHook(OnlyPatchCheck,Buf2,My_RtlCreateProcessParameters_Type3,Func_RtlCreateProcessParameters,7,&OrigContAddr_RtlCreateProcessParameters,CurProcess);
                    }
                  else if (!memcmp(Buf,"\x64\xA1\x00\x00\x00\x00",6))
                    {
                      Result = SetHook(OnlyPatchCheck,Buf2,My_RtlCreateProcessParameters_Type4,Func_RtlCreateProcessParameters,6,&OrigContAddr_RtlCreateProcessParameters,CurProcess);
                    }
                }
            }

          PVOID Func_NtCreateFile = GetProcAddress(NtDllInstance,"NtCreateFile");
          if (Result && Func_NtCreateFile)
            {
              Result = false;
              if (ReadProcessMemory(CurProcess,Func_NtCreateFile,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                {
                  if (!memcmp(Buf,"\xb8",1))
                    {
                      OrigValue_NtCreateFile = *(LPDWORD)(Buf + 1);
                      Result = SetHook(OnlyPatchCheck,Buf2,My_NtCreateFile_Type1,Func_NtCreateFile,5,&OrigContAddr_NtCreateFile,CurProcess);
                    }
                }
            }

          PVOID Func_NtOpenFile = GetProcAddress(NtDllInstance,"NtOpenFile");
          if (Result && Func_NtOpenFile)
            {
              Result = false;
              if (ReadProcessMemory(CurProcess,Func_NtOpenFile,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                {
                  if (!memcmp(Buf,"\xb8",1))
                    {
                      if (PatchFlags & pf_SkipOpenFile)
                        Result = true;
                      else
                        {
                          OrigValue_NtOpenFile = *(LPDWORD)(Buf + 1);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_NtOpenFile_Type1,Func_NtOpenFile,5,&OrigContAddr_NtOpenFile,CurProcess);
                        }
                    }
                }
            }

          PVOID Func_NtDeleteFile = GetProcAddress(NtDllInstance,"NtDeleteFile");
          if (Result && Func_NtDeleteFile)
            {
              Result = false;
              if (ReadProcessMemory(CurProcess,Func_NtDeleteFile,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                {
                  if (!memcmp(Buf,"\xb8",1))
                    {
                      OrigValue_NtDeleteFile = *(LPDWORD)(Buf + 1);
                      Result = SetHook(OnlyPatchCheck,Buf2,My_NtDeleteFile_Type1,Func_NtDeleteFile,5,&OrigContAddr_NtDeleteFile,CurProcess);
                    }
                }
            }
        }
    }

  if (Result && !(PatchFlags & pf_SkipOLE))
    {
      Result = false;

      const char *Ole32LibName = "ole32.dll";
      HINSTANCE Ole32Instance = GetModuleHandle(Ole32LibName);
      if (!Ole32Instance)
        {
          Ole32Instance = LoadLibrary(Ole32LibName);
          if (Ole32Instance)
            Ole32InstanceLoaded = true;
        }
      if (Ole32Instance)
        {
          PVOID Func_CoCreateInstanceEx = GetProcAddress(Ole32Instance,"CoCreateInstanceEx");
          PVOID Func_CoGetClassObject   = GetProcAddress(Ole32Instance,"CoGetClassObject");
          if (Func_CoCreateInstanceEx && Func_CoGetClassObject)
            {
              Result = true;
              if (Result)
                {
                  Result = false;
                  if (ReadProcessMemory(CurProcess,Func_CoCreateInstanceEx,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x33\xC0",5))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoCreateInstanceEx_Type1,Func_CoCreateInstanceEx,5,&OrigContAddr_CoCreateInstanceEx,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x6A\x00",5))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoCreateInstanceEx_Type2,Func_CoCreateInstanceEx,5,&OrigContAddr_CoCreateInstanceEx,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\xE8",4))
                        {
                          OrigCallAddr_CoCreateInstanceEx = (PVOID)((DWORD)Func_CoCreateInstanceEx + (*(LPDWORD)(Buf + 4)) + 8);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoCreateInstanceEx_Type3,Func_CoCreateInstanceEx,8,&OrigContAddr_CoCreateInstanceEx,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x81\xEC\x78\x02\x00\x00",9))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoCreateInstanceEx_Type4,Func_CoCreateInstanceEx,9,&OrigContAddr_CoCreateInstanceEx,CurProcess);
                        }
                    }
                }
              if (Result)
                {
                  Result = false;
                  if (ReadProcessMemory(CurProcess,Func_CoGetClassObject,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x6A\x00",5))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoGetClassObject_Type1,Func_CoGetClassObject,5,&OrigContAddr_CoGetClassObject,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\xE8",4))
                        {
                          OrigCallAddr_CoGetClassObject = (PVOID)((DWORD)Func_CoGetClassObject + (*(LPDWORD)(Buf + 4)) + 8);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoGetClassObject_Type2,Func_CoGetClassObject,8,&OrigContAddr_CoGetClassObject,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x56\xFF\x75\x18",7))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoGetClassObject_Type3,Func_CoGetClassObject,7,&OrigContAddr_CoGetClassObject,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x33\xC0\x8B\xEC",5))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_CoGetClassObject_Type4,Func_CoGetClassObject,5,&OrigContAddr_CoGetClassObject,CurProcess);
                        }
                    }
                }
            }
        }
    }

  if (Result && !(PatchFlags & pf_SkipWinINet))
    {
      Result = false;

      const char *WinINetLibName = "wininet.dll";
      HINSTANCE WinINetInstance = GetModuleHandle(WinINetLibName);
      if (!WinINetInstance)
        {
          WinINetInstance = LoadLibrary(WinINetLibName);
          if (WinINetInstance)
            WinINetInstanceLoaded = true;
        }
      if (WinINetInstance)
        {
          Result = true;
          if (Result)
            {
              Result = false;
              PVOID Func_InternetConnectA = GetProcAddress(WinINetInstance,"InternetConnectA");
              if (Func_InternetConnectA)
                {
                  if (ReadProcessMemory(CurProcess,Func_InternetConnectA,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8D\xAC\x24\xD8\xFD\xFF\xFF",8))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetConnectA_Type1,Func_InternetConnectA,8,&OrigContAddr_InternetConnectA,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8D\x6C\x24\xA8",5))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetConnectA_Type2,Func_InternetConnectA,5,&OrigContAddr_InternetConnectA,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x81\xEC",5))
                        {
                          OrigValue_InternetConnectA = *(LPDWORD)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetConnectA_Type3,Func_InternetConnectA,9,&OrigContAddr_InternetConnectA,CurProcess);
                        }
                    }
                }
            }
          if (Result)
            {
              Result = false;
              PVOID Func_InternetConnectW = GetProcAddress(WinINetInstance,"InternetConnectW");
              if (Func_InternetConnectW)
                {
                  if (ReadProcessMemory(CurProcess,Func_InternetConnectW,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_InternetConnectW = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetConnectW_Type1,Func_InternetConnectW,6,&OrigContAddr_InternetConnectW,CurProcess);
                        }
                    }
                }
            }

          if (Result)
            {
              Result = false;
              PVOID Func_InternetOpenUrlA = GetProcAddress(WinINetInstance,"InternetOpenUrlA");
              if (Func_InternetOpenUrlA)
                {
                  if (ReadProcessMemory(CurProcess,Func_InternetOpenUrlA,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x6A\x24\x68",3))
                        {
                          OrigPushAddr_InternetOpenUrlA = *(LPDWORD)(Buf + 3);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetOpenUrlA_Type1,Func_InternetOpenUrlA,7,&OrigContAddr_InternetOpenUrlA,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x6A\xFF",5))
                        {
                          OrigPushAddr_InternetOpenUrlA = *(LPDWORD)(Buf + 3);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetOpenUrlA_Type2,Func_InternetOpenUrlA,5,&OrigContAddr_InternetOpenUrlA,CurProcess);
                        }
                    }
                }
            }
          if (Result)
            {
              Result = false;
              PVOID Func_InternetOpenUrlW = GetProcAddress(WinINetInstance,"InternetOpenUrlW");
              if (Func_InternetOpenUrlW)
                {
                  if (ReadProcessMemory(CurProcess,Func_InternetOpenUrlW,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_InternetOpenUrlW = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetOpenUrlW_Type1,Func_InternetOpenUrlW,6,&OrigContAddr_InternetOpenUrlW,CurProcess);
                        }
                    }
                }
            }

          if (Result)
            {
              Result = false;
              PVOID Func_InternetReadFile = GetProcAddress(WinINetInstance,"InternetReadFile");
              if (Func_InternetReadFile)
                {
                  if (ReadProcessMemory(CurProcess,Func_InternetReadFile,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_InternetReadFile = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetReadFile_Type1,Func_InternetReadFile,6,&OrigContAddr_InternetReadFile,CurProcess);
                        }
                    }
                }
            }
          if (Result)
            {
              Result = false;
              PVOID Func_InternetReadFileExA = GetProcAddress(WinINetInstance,"InternetReadFileExA");
              if (Func_InternetReadFileExA)
                {
                  if (ReadProcessMemory(CurProcess,Func_InternetReadFileExA,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_InternetReadFileExA = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetReadFileExA_Type1,Func_InternetReadFileExA,6,&OrigContAddr_InternetReadFileExA,CurProcess);
                        }
                    }
                }
            }

          if (Result)
            {
              Result = false;
              PVOID Func_InternetWriteFile = GetProcAddress(WinINetInstance,"InternetWriteFile");
              if (Func_InternetWriteFile)
                {
                  if (ReadProcessMemory(CurProcess,Func_InternetWriteFile,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_InternetWriteFile = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_InternetWriteFile_Type1,Func_InternetWriteFile,6,&OrigContAddr_InternetWriteFile,CurProcess);
                        }
                    }
                }
            }

          if (Result)
            {
              Result = false;
              PVOID Func_HttpSendRequestA = GetProcAddress(WinINetInstance,"HttpSendRequestA");
              if (Func_HttpSendRequestA)
                {
                  if (ReadProcessMemory(CurProcess,Func_HttpSendRequestA,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x6A",4))
                        {
                          OrigValue_HttpSendRequestA = *(char *)(Buf + 4);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_HttpSendRequestA_Type1,Func_HttpSendRequestA,5,&OrigContAddr_HttpSendRequestA,CurProcess);
                        }
                    }
                }
            }
          if (Result)
            {
              Result = false;
              PVOID Func_HttpSendRequestW = GetProcAddress(WinINetInstance,"HttpSendRequestW");
              if (Func_HttpSendRequestW)
                {
                  if (ReadProcessMemory(CurProcess,Func_HttpSendRequestW,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_HttpSendRequestW = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_HttpSendRequestW_Type1,Func_HttpSendRequestW,6,&OrigContAddr_HttpSendRequestW,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x51\x51",5))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_HttpSendRequestW_Type2,Func_HttpSendRequestW,5,&OrigContAddr_HttpSendRequestW,CurProcess);
                        }
                    }
                }
            }
          if (Result)
            {
              Result = false;
              PVOID Func_HttpOpenRequestA = GetProcAddress(WinINetInstance,"HttpOpenRequestA");
              if (Func_HttpOpenRequestA)
                {
                  if (ReadProcessMemory(CurProcess,Func_HttpOpenRequestA,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_HttpOpenRequestA = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_HttpOpenRequestA_Type1,Func_HttpOpenRequestA,6,&OrigContAddr_HttpOpenRequestA,CurProcess);
                        }
                    }
                }
            }
          if (Result)
            {
              Result = false;
              PVOID Func_HttpOpenRequestW = GetProcAddress(WinINetInstance,"HttpOpenRequestW");
              if (Func_HttpOpenRequestW)
                {
                  if (ReadProcessMemory(CurProcess,Func_HttpOpenRequestW,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue_HttpOpenRequestW = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_HttpOpenRequestW_Type1,Func_HttpOpenRequestW,6,&OrigContAddr_HttpOpenRequestW,CurProcess);
                        }
                    }
                }
            }
        }
    }

  if (Result && !(PatchFlags & pf_SkipWinSock))
    {
      Result = false;

      const char *WinSockLibName = "ws2_32.dll";
      HINSTANCE WinSockInstance = GetModuleHandle(WinSockLibName);
      if (!WinSockInstance)
        WinSockInstance = LoadLibrary(WinSockLibName);
      if (WinSockInstance)
        {
          Result = true;
          if (Result)
            {
              Result = false;
              PVOID Func_WSALookupServiceNextW = GetProcAddress(WinSockInstance,"WSALookupServiceNextW");
              if (Func_WSALookupServiceNextW)
                {
                  if (ReadProcessMemory(CurProcess,Func_WSALookupServiceNextW,Buf,sizeof Buf,&BytesRead) && (BytesRead == sizeof Buf))
                    {
                      if (!memcmp(Buf,"\x55\x8B\xEC\x81\x3D",5))
                        {
                          OrigValue1_WSALookupServiceNextW = *(LPDWORD)(Buf + 5);
                          OrigValue2_WSALookupServiceNextW = *(LPDWORD)(Buf + 9);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_WSALookupServiceNextW_Type1,Func_WSALookupServiceNextW,13,&OrigContAddr_WSALookupServiceNextW,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x51\x51",5))
                        {
                          Result = SetHook(OnlyPatchCheck,Buf2,My_WSALookupServiceNextW_Type3,Func_WSALookupServiceNextW,5,&OrigContAddr_WSALookupServiceNextW,CurProcess);
                        }
                      else if (!memcmp(Buf,"\x55\x8B\xEC\x83\xEC",5))
                        {
                          OrigValue1_WSALookupServiceNextW = *(char *)(Buf + 5);
                          Result = SetHook(OnlyPatchCheck,Buf2,My_WSALookupServiceNextW_Type2,Func_WSALookupServiceNextW,6,&OrigContAddr_WSALookupServiceNextW,CurProcess);
                        }
                    }
                }
            }
        }
    }


  if (Result && !OnlyPatchCheck)
    StartWatchThread();

  return Result;
}

